--
-- Mod: Animals Hud
--
-- Author: xDeekay + michel
-- email: domkopp29@gmail.com (xDeekay)
-- @Date: 17.12.2018
-- @Update 3.5.0.4 beta Date: 09.12.2019
-- @Version: 3.5.0.4
-- Copyright (C) xDeekay, All Rights Reserved.

animalsHUD = {};

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");

animalsChickenHudActive = false;  -- is saved in xml file
animalsCowHudActive = false;      -- is saved in xml file
animalsHorseHudActive = false;    -- is saved in xml file
animalsPigHudActive = false;      -- is saved in xml file
animalsSheepHudActive = false;    -- is saved in xml file

-- combined food display
combiFiLvActive = false;          -- is saved in xml file
-- minimized display WITHOUT column 3 and 4
minimizeHudActive = false;        -- is saved in xml file
-- short display WITHOUT products and productivity
shortHudActive = false;           -- is saved in xml file

hideAllOnHudActive = false;       -- hardcoded value; is NOT saved in xml file (of course)
activeHUDs = 0;

-- ++++++++++++++++++++++++++++++++++++++++

-- global position of HUD (standard position ist top right under the seasons hud)
HUD_position_horizontal = 0.99  -- standard value is 0.99; is NOT saved in xml file 
HUD_position_vertictal = 0.86   -- standard value is 0.86; is NOT saved in xml file 

-- ++++++++++++++++++++++++++++++++++++++++

-- Anzeigeart der Tiere (siehe 'AnimalsHUD - Info.txt')

-- Startwerte
animalPicType = 1                -- is saved in xml file
animalPicFolder = "1_seasons"    -- is saved in xml file
-- Start in Runde 1 ohne Transparenz
animalPicRound = 1               -- is saved in xml file

-- Transparenzstaerke der Tiere in jeder zweiten Runde
animalPicTransp = 0.4            -- hardcoded value; is NOT saved in xml file
-- Anzahl der Styleordner (kann hier jederzeit ganz einfach erweitert werden)
animalPicStyles = 6              -- hardcoded value; is NOT saved in xml file

-- ++++++++++++++++++++++++++++++++++++++++

-- other nice variables

-- display of huds automatically, if player nearer than [radiusBarns] meters (for too long hud list, e.g. if many own barns)
showNearBarnsOnly = true;

-- radius for hud display, if player is near barn (only outside vehicle at this time)
radiusBarns = 90.0   -- ca. distance in meters

-- radius for 'here I am' star, if player is near barn
radius = 45.0        -- ca. distance in meters

-- changing background color (-1 = NO backgrounds / 0 = one color for each animal / 1 = all red / 2 = all blue / 3 = all green / 4 = all brown / 5 = all purple)
backgroundColorConfig = 0

-- transparency of the colored background overlays
backgroundTransparency = 0.7

-- distance after title row and productivity row
distAfterTitleFactor = 1.25

-- decimal places displayed (productivity, cleanliness, water, straw, food)
-- allowed values are 0, 1 or 2
decimalPlacesInHUD = 1

-- ++++++++++++++++++++++++++++++++++++++++

-- 1 for no decimal place, 10 for 1 decimal places, 100 for 2 decimal places
decimalPlacesFactor2 = 1
if decimalPlacesInHUD == 0 then
	decimalPlacesFactor2 = 1
end
if decimalPlacesInHUD == 1 then
	decimalPlacesFactor2 = 10
end
if decimalPlacesInHUD == 2 then
	decimalPlacesFactor2 = 100
end

decimalPlacesFactor1 = 100 * decimalPlacesFactor2   -- 100 for no decimal place, 1000 for 1 decimal places, 10000 for 2 decimal places

-- ++++++++++++++++++++++++++++++++++++++++

-- search for food IDs of MoreBunkerSilo

-- Flag fuer die einmalige Suche nach den dynamische IDs von MoreBunkerSilo
searchFlagDynID = 0
IDfoundFlagGRSIL = 0
IDfoundFlagCCM = 0

-- Anzeige im Log.txt - 0 (none), 1 (short), 2 (full)
searchLogTxtFlag = 1

-- ++++++++++++++++++++++++++++++++++++++++

-- Auswahl fuer Seasons und MoreBunkerSilo
-- das wird erst in der function checkSelectedMods wirklich geprft
SeasonsIsActive        = false  -- don't change here !
MoreBunkerSiloIsActive = false  -- don't change here !

-- ++++++++++++++++++++++++++++++++++++++++




numberOfHudsActiveOnScreen = {animalsChickenHudActive = false, animalsCowHudActive = false, animalsPigHudActive = false, animalsHorseHudActive = false, animalsSheepHudActive = false, hideAllOnHudActive = false}

fontSize = 0.010;  -- is saved in xml file
fontSizeMin = 0.006
fontSizeMax = 0.012
fontSizeChange = 0.00025;

animalsHUD.version = getXMLString(modDesc, "modDesc.version");
animalsHUD.modDirectory = g_currentModDirectory;

language = {}
animalsHUD.overlay = {}
animalsHUD.overlay2 = {}

addModEventListener(animalsHUD);

function animalsHUD:loadMap()
	print("############################################################");
	print("--- Animals HUD Version: " .. self.version .. ", by xDeekay / Michel");
	print("############################################################");

	inputsActiveHUDs = false
	animalsHUD.settingsDir = getUserProfileAppPath().. "modsSettings/animalsHUD/";

	animalsHUD:LoadSettings();
	animalsHUD:SaveSettings();

	-- get language from giants engine for fruits and animals name
	-- ID 2 = WEIZEN
	-- ID 3 = GERSTE
	-- ID 4 = HAFER
	-- ID 5 = RAPS
	-- ID 6 = SONNENBLUMEN
	-- ID 7 = SOYABOHNEN
	-- ID 8 = MAIS
	-- ID 9 = KARTOFFEL
	-- ID 10 = ZUCKERRUEBEN
	-- ID 14 Pallets Chicken Eggs goes in game to 1?!
	-- ID 15 Pallets Sheep wool goes in game to 1 !?!
	-- ID 16 milk Cows
	-- ID 18 = WASSER
	-- ID 19 = MISCHRATION
	-- ID 24 = SILAGE 
	-- ID 28 = GRAS
	-- ID 30 = HEU
	-- ID 31 = STROH
	-- ID 45 manure (mist) Cows, pigs
	-- ID 46 liquid manure (guelle) Cows, pigs

	-- MoreBunkSilo bringt folgende Fruchtarten mit
	-- CCM (ID = ??)
	-- Grassilage (ID = ??)
	
	
	varID_wheat        =  2      -- WEIZEN
	varID_barley       =  3      -- GERSTE
	varID_oat          =  4      -- HAFER
	varID_canola       =  5      -- RAPS
	varID_soybean      =  7      -- SOJABOHNEN
	varID_sunflower    =  6      -- SONNENBLUMEN
	varID_maize        =  8      -- MAIS
	varID_potato       =  9      -- KARTOFFEL     -> von Seasons deaktiviert !
	varID_sugarbeet    = 10      -- ZUCKERRUEBEN  -> von Seasons deaktiviert !
	varID_palleteggs   = 14      -- Pallets Chicken Eggs (goes in game to 1?!)
	varID_palletwool   = 15      -- Pallets Sheep wool (goes in game to 1 !?!)
	varID_milk         = 16      -- MILCH -> cows
	varID_water        = 18      -- WASSER
	varID_forage       = 19      -- MISCHRATION
	varID_silage       = 24      -- SILAGE 
	varID_grass        = 28      -- GRAS
	varID_drygrass     = 30      -- HEU
	varID_straw        = 31      -- STROH
	varID_manure       = 45      -- manure (mist) -> cows, pigs
	varID_liquidmanure = 46      -- liquid manure (guelle) -> cows, pigs

	--MoreBunkerSilo - calculation neccessary
	-- varID_ccm          = ??   -- CCM -> pigs
	-- varID_grassilage   = ??   -- GRASSILAGE -> cows, sheeps

	language.fruits = {
	gras         = g_i18n:getText("fillType_grass"),
	hafer         = g_i18n:getText("fillType_oat"),
	weizen        = g_i18n:getText("fillType_wheat"), 
	zuckerrueben  = g_i18n:getText("fillType_sugarBeet"),  
	kartoffeln    = g_i18n:getText("fillType_potato"),  
	gerste        = g_i18n:getText("fillType_barley"),  
	sojabohnen    = g_i18n:getText("fillType_soybean"), 
	mischration   = g_i18n:getText("fillType_forage"), 
	stroh         = g_i18n:getText("fillType_straw"), 
	silage        = g_i18n:getText("fillType_silage"), 
	heu           = g_i18n:getText("fillType_dryGrass"),  
	mais          = g_i18n:getText("fillType_maize"),  
	raps          = g_i18n:getText("fillType_canola"), 
	wasser        = g_i18n:getText("fillType_water"),  
	sonnenblumen  = g_i18n:getText("fillType_sunflower"),

	-- MoreBunkerSilo (leider hardcoded in den modDesc_de/modDESC_en - werden die Namen in LS nicht richtig registriert ?)
	ccm           = g_i18n:getText("word_ccm"),
	grassilage    = g_i18n:getText("word_grassilage"),
	}

	language.animals = {
	huehnerbestand     = g_i18n:getText("helpTitle_25"),
	kuhbestand         = g_i18n:getText("helpTitle_21"),
	schweinebestand    = g_i18n:getText("helpTitle_20"),
	pferdebestand      = g_i18n:getText("helpTitle_19_01"),
	schafebestand      = g_i18n:getText("helpTitle_24"),
	sauberkeit         = g_i18n:getText("statistic_cleanliness"), 
	produktivitaet     = g_i18n:getText("statistic_productivity"), 
	milch              = g_i18n:getText("fillType_milk"), 
	mist               = g_i18n:getText("fillType_manure"), 
	guelle             = g_i18n:getText("fillType_liquidManure"), 
	wolle              = g_i18n:getText("fillType_wool"),  
	eier               = g_i18n:getText("fillType_egg"),  
	}
end;

--	self.startUpdateTime = 2000; -- Wait 2 sec to show any messages.
function animalsHUD:SaveSettings() -- set the xml settings if not given
	createFolder(getUserProfileAppPath() .. "modsSettings/");
	createFolder(animalsHUD.settingsDir);
	
	local file = animalsHUD.settingsDir.. "animalsHUD_v2.xml";
	local xmlContent = nil
	local xmlVersion = 3.5;

--	local groupNameTag = string.format("%s.setting(%d)", "animalsHUD.settings", 0);

--	if not fileExists(file) or not loadCfg then								
	if not fileExists(file) then -- new values save to a xml file
		xmlContent = createXMLFile("animalsHUD_XML", file, "animalsHUD");		

		-- version
		local groupNameTag = ("animalsHUD.settings.version(%d)"):format(0);
		setXMLString(xmlContent, groupNameTag .. "#xmlVersion", tostring(xmlVersion));

		-- fontsize
		groupNameTag = ("animalsHUD.settings.fontsize(%d)"):format(0);
		setXMLFloat(xmlContent, groupNameTag .. "#fontsize", fontSize);

		-- animal hud visibility
		groupNameTag = ("animalsHUD.settings.hudstatus.animals.chicken(%d)"):format(0);
		setXMLBool(xmlContent, groupNameTag .. "#ChickenHudActive", animalsChickenHudActive);
		groupNameTag = ("animalsHUD.settings.hudstatus.animals.cows(%d)"):format(0);
		setXMLBool(xmlContent, groupNameTag .. "#CowHudActive", animalsCowHudActive);
		groupNameTag = ("animalsHUD.settings.hudstatus.animals.pigs(%d)"):format(0);
		setXMLBool(xmlContent, groupNameTag .. "#PigHudActive", animalsPigHudActive);
		groupNameTag = ("animalsHUD.settings.hudstatus.animals.horses(%d)"):format(0);
		setXMLBool(xmlContent, groupNameTag .. "#HorseHudActive", animalsHorseHudActive);
		groupNameTag = ("animalsHUD.settings.hudstatus.animals.sheeps(%d)"):format(0);
		setXMLBool(xmlContent, groupNameTag .. "#SheepHudActive", animalsSheepHudActive);

		-- hud display options
		groupNameTag = ("animalsHUD.settings.hudstatus.display.combined(%d)"):format(0);
		setXMLBool(xmlContent, groupNameTag .. "#combinedDisplay", combiFiLvActive);
		groupNameTag = ("animalsHUD.settings.hudstatus.display.minimized(%d)"):format(0);
		setXMLBool(xmlContent, groupNameTag .. "#minimizedDisplay", minimizeHudActive);
		groupNameTag = ("animalsHUD.settings.hudstatus.display.short(%d)"):format(0);
		setXMLBool(xmlContent, groupNameTag .. "#shortDisplay", shortHudActive);

		-- hud config values
		groupNameTag = ("animalsHUD.settings.hudstatus.config.pictype(%d)"):format(0);
		setXMLInt(xmlContent, groupNameTag .. "#pictypeVar", animalPicType);
		groupNameTag = ("animalsHUD.settings.hudstatus.config.picfolder(%d)"):format(0);
		setXMLString(xmlContent, groupNameTag .. "#picfolderVar", animalPicFolder);
		groupNameTag = ("animalsHUD.settings.hudstatus.config.picround(%d)"):format(0);
		setXMLInt(xmlContent, groupNameTag .. "#picroundVar", animalPicRound);

		saveXMLFile(xmlContent);	
	else -- if the file exists and data must or should be updated.
		if fileExists(file) then 
			xmlContent = loadXMLFile("animalsHUD_XML", file, "animalsHUD")

			local groupNameTag = ("animalsHUD.settings.version(%d)"):format(0);
			setXMLString(xmlContent, groupNameTag .. "#xmlVersion", tostring(xmlVersion));

			groupNameTag = ("animalsHUD.settings.fontsize(%d)"):format(0);
			setXMLFloat(xmlContent, groupNameTag .. "#fontsize", fontSize); -- set here the currentFontSize

			groupNameTag = ("animalsHUD.settings.hudstatus.animals.chicken(%d)"):format(0);
			setXMLBool(xmlContent, groupNameTag .. "#ChickenHudActive", animalsChickenHudActive);
			groupNameTag = ("animalsHUD.settings.hudstatus.animals.cows(%d)"):format(0);
			setXMLBool(xmlContent, groupNameTag .. "#CowHudActive", animalsCowHudActive);
			groupNameTag = ("animalsHUD.settings.hudstatus.animals.pigs(%d)"):format(0);
			setXMLBool(xmlContent, groupNameTag .. "#PigHudActive", animalsPigHudActive);
			groupNameTag = ("animalsHUD.settings.hudstatus.animals.horses(%d)"):format(0);
			setXMLBool(xmlContent, groupNameTag .. "#HorseHudActive", animalsHorseHudActive);
			groupNameTag = ("animalsHUD.settings.hudstatus.animals.sheeps(%d)"):format(0);
			setXMLBool(xmlContent, groupNameTag .. "#SheepHudActive", animalsSheepHudActive);

			groupNameTag = ("animalsHUD.settings.hudstatus.display.combined(%d)"):format(0);
			setXMLBool(xmlContent, groupNameTag .. "#combinedDisplay", combiFiLvActive);
			groupNameTag = ("animalsHUD.settings.hudstatus.display.minimized(%d)"):format(0);
			setXMLBool(xmlContent, groupNameTag .. "#minimizedDisplay", minimizeHudActive);
			groupNameTag = ("animalsHUD.settings.hudstatus.display.short(%d)"):format(0);
			setXMLBool(xmlContent, groupNameTag .. "#shortDisplay", shortHudActive);

			groupNameTag = ("animalsHUD.settings.hudstatus.config.pictype(%d)"):format(0);
			setXMLInt(xmlContent, groupNameTag .. "#pictypeVar", animalPicType);
			groupNameTag = ("animalsHUD.settings.hudstatus.config.picfolder(%d)"):format(0);
			setXMLString(xmlContent, groupNameTag .. "#picfolderVar", animalPicFolder);
			groupNameTag = ("animalsHUD.settings.hudstatus.config.picround(%d)"):format(0);
			setXMLInt(xmlContent, groupNameTag .. "#picroundVar", animalPicRound);

			saveXMLFile(xmlContent);	
		else 
			print("WARNING: AnimalsHud_V2.xml was removed or does not exist.")
		end
	end 
end

function animalsHUD:LoadSettings()
	local file = animalsHUD.settingsDir.. "animalsHUD_v2.xml";
	local xmlContent = nil

	if fileExists(file) then 
		xmlContent = loadXMLFile("animalsHUD_XML", file, "animalsHUD")

		local groupNameTag = ("animalsHUD.settings.version(%d)"):format(0);
		xmlVersion = Utils.getNoNil(getXMLString(xmlContent, groupNameTag .. "#xmlVersion"), "");

		groupNameTag = ("animalsHUD.settings.fontsize(%d)"):format(0);
		fontSize = Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#fontsize"), "");

		groupNameTag = ("animalsHUD.settings.hudstatus.animals.chicken(%d)"):format(0);
		animalsChickenHudActive   = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#ChickenHudActive"), false);
		groupNameTag = ("animalsHUD.settings.hudstatus.animals.cows(%d)"):format(0);
		animalsCowHudActive       = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#CowHudActive"), false);
		groupNameTag = ("animalsHUD.settings.hudstatus.animals.pigs(%d)"):format(0);
		animalsPigHudActive       = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#PigHudActive"), false);
		groupNameTag = ("animalsHUD.settings.hudstatus.animals.horses(%d)"):format(0);
		animalsHorseHudActive     = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#HorseHudActive"), false);
		groupNameTag = ("animalsHUD.settings.hudstatus.animals.sheeps(%d)"):format(0);
		animalsSheepHudActive     = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#SheepHudActive"), false);

		groupNameTag = ("animalsHUD.settings.hudstatus.display.combined(%d)"):format(0);
		combiFiLvActive           = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#combinedDisplay"), false);
		groupNameTag = ("animalsHUD.settings.hudstatus.display.minimized(%d)"):format(0);
		minimizeHudActive          = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#minimizedDisplay"), false);
		groupNameTag = ("animalsHUD.settings.hudstatus.display.short(%d)"):format(0);
		shortHudActive           = Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#shortDisplay"), false);

		groupNameTag = ("animalsHUD.settings.hudstatus.config.pictype(%d)"):format(0);
		animalPicType     = Utils.getNoNil(getXMLInt(xmlContent, groupNameTag .. "#pictypeVar"), false);
		groupNameTag = ("animalsHUD.settings.hudstatus.config.picfolder(%d)"):format(0);
		animalPicFolder   = Utils.getNoNil(getXMLString(xmlContent, groupNameTag .. "#picfolderVar"), false);
		groupNameTag = ("animalsHUD.settings.hudstatus.config.picround(%d)"):format(0);
		animalPicRound   = Utils.getNoNil(getXMLInt(xmlContent, groupNameTag .. "#picroundVar"), false);
	else 
		print("WARNING: AnimalsHud_V2.xml was removed or does not exist.")
	end
end

function animalsHUD:keyEvent(unicode, sym, modifier, isDown)
end;

function animalsHUD:mouseEvent(posX, posY, isDown, isUp, button)
end;


function animalsHUD:deleteMap()
end;

function animalsHUD:ShowChicken()
	-- in Arbeit ...
	-- wenn alle HUDs bereits einzelnd aus und die globale Aus-Funktion aktiviert ist
--[[
	if activeHUDs == 0 or hideAllOnHudActive == true then
if animalsChickenHudActive == true then
print("1: true " .. activeHUDs)
else
print("1: false " .. activeHUDs)
end
		animalsChickenHudActive =not animalsChickenHudActive;
if animalsChickenHudActive == true then
print("2: true " .. activeHUDs)
else
print("2: false " .. activeHUDs)
end
	 	hideAllOnHudActive = false
	else
		animalsChickenHudActive =not animalsChickenHudActive;
	end
if animalsChickenHudActive == true then
print("3: true " .. activeHUDs)
else
print("3: false " .. activeHUDs)
end
]]--


	animalsChickenHudActive =not animalsChickenHudActive;

	-- set the count for huds on screen
	numberOfHudsActiveOnScreen.animalsChickenHudActive = animalsChickenHudActive
	hudsActiveCount() -- set the number of active huds

	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()
--[[
if animalsChickenHudActive == true then
print("4: true " .. activeHUDs)
else
print("4: false " .. activeHUDs)
end
]]--
end

function animalsHUD:ShowCows()
	animalsCowHudActive =not animalsCowHudActive;

	-- set the count for huds on screen
	numberOfHudsActiveOnScreen.animalsCowHudActive = animalsCowHudActive
	hudsActiveCount() -- set the number of active huds

	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()

	-- MANUELLE Neuberechnung - Aufruf der ID-Messfunktion, notwendig bei Stallkauf KUEHE (oder Schafe)
	if IDfoundFlagGRSIL == 0 and MoreBunkerSiloIsActive == true then
		-- WICHTIG: BEIDE Werte sicherheitshalber neu messen (wie Erstberechnung)
		searchFlagDynID = 1
		IDfoundFlagCCM = 0

		getMBSdynamicIDs()
		searchFlagDynID = 2
	end
end

function animalsHUD:ShowPigs()
	animalsPigHudActive =not animalsPigHudActive;

	-- set the count for huds on screen
	numberOfHudsActiveOnScreen.animalsPigHudActive = animalsPigHudActive
	hudsActiveCount() -- set the number of active huds

	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()

	-- MANUELLE Neuberechnung - Aufruf der ID-Messfunktion, notwendig bei Stallkauf SCHWEINE
	if IDfoundFlagCCM == 0 and MoreBunkerSiloIsActive == true then
		-- WICHTIG: BEIDE Werte sicherheitshalber neu messen (wie Erstberechnung)
		searchFlagDynID = 1
		IDfoundFlagGRSIL = 0

		getMBSdynamicIDs()
		searchFlagDynID = 2
	end
end

function animalsHUD:ShowHorses()
	animalsHorseHudActive =not animalsHorseHudActive;

	-- set the count for huds on screen
	numberOfHudsActiveOnScreen.animalsHorseHudActive = animalsHorseHudActive
	hudsActiveCount() -- set the number of active huds

	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()
end

function animalsHUD:ShowSheeps()
	animalsSheepHudActive =not animalsSheepHudActive;

	-- set the count for huds on screen
	numberOfHudsActiveOnScreen.animalsSheepHudActive = animalsSheepHudActive
	hudsActiveCount() -- set the number of active huds
	
	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()

	-- MANUELLE Neuberechnung - Aufruf der ID-Messfunktion, notwendig bei Stallkauf SCHAFE (oder Kuehe)
	if IDfoundFlagGRSIL == 0 and MoreBunkerSiloIsActive == true then
		-- WICHTIG: BEIDE Werte sicherheitshalber neu messen (wie Erstberechnung)
		searchFlagDynID = 1
		IDfoundFlagCCM = 0

		getMBSdynamicIDs()
		searchFlagDynID = 2
	end
end

function animalsHUD:FontSizeIncrease()
	-- FontSize nach oben begrenzen
	if fontSize < fontSizeMax then
		fontSize = fontSize + fontSizeChange
	end
	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()
end

function animalsHUD:FontSizeDecrease()
	-- FontSize nach oben begrenzen
	if fontSize > fontSizeMin then
		fontSize = fontSize - fontSizeChange
	end
	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()
end

function animalsHUD:CombiFiLv()
	combiFiLvActive =not combiFiLvActive

	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()
end

function animalsHUD:MinimizeHud()
	minimizeHudActive =not minimizeHudActive

	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()
end

function animalsHUD:ShortHud()
	shortHudActive =not shortHudActive;

	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()
end

function animalsHUD:ShowHideAllOnHud()
	hideAllOnHudActive =not hideAllOnHudActive

	-- in Arbeit ...
	-- wenn alle HUDs einzelnd aus sind, dann wird die globale Aus-Funktion deaktiviert
	-- hudsActiveCount() -- set the number of active huds
	-- if activeHUDs == 0 then
	-- 	hideAllOnHudActive = false
	-- end

	-- MANUELLE Neuberechnung - Aufruf der ID-Messfunktion, notwendig bei Stallkauf SCHWEINE, KUEHE ODER SCHAFE
	if IDfoundFlagGRSIL == 0 or IDfoundFlagCCM == 0 then
		if MoreBunkerSiloIsActive == true then
			-- WICHTIG: BEIDE Werte sicherheitshalber neu messen (wie Erstberechnung)
			searchFlagDynID = 1
			IDfoundFlagCCM = 0
			IDfoundFlagGRSIL = 0

			getMBSdynamicIDs()
			searchFlagDynID = 2
		end
	end
end

function animalsHUD:PicTypeHud()
	animalPicType = animalPicType + 1

	-- Laufwert von 0 bis derzeit 5
	if animalPicType > animalPicStyles then
		animalPicType = 0
		animalPicRound = animalPicRound + 1
	end

	if animalPicRound > 2 then
		animalPicRound = 1
	end

	-- Laufwert von 1 bis 2 (2 ist die Halbtransparenz)
	if animalPicType > animalPicStyles then
		animalPicType = 0
	end

	-- zur Sicherheit
	animalPicFolder = "1_seasons"

	-- bei Wert 0 werden die Bilder gar nicht angzeigt, siehe func createOverlayForAnimalsHUD()
	if animalPicType == 1 then
		animalPicFolder = "1_seasons"
	end
	if animalPicType == 2 then
		animalPicFolder = "2_seasons_color"
	end
	if animalPicType == 3 then
		animalPicFolder = "3_real"
	end
	if animalPicType == 4 then
		animalPicFolder = "4_free1"
	end
	if animalPicType == 5 then
		animalPicFolder = "5_free2"
	end
	if animalPicType == 6 then
		animalPicFolder = "6_free3"
	end

	animalsHUD:SaveSettings()
	animalsHUD:LoadSettings()
end

function animalsHUD:update(dt)
	if g_currentMission:getIsClient() then
		if g_gui.currentGui == nil and g_currentMission.controlledVehicle == nil then
			if not inputsActive then
				local _1, eventShowChicken = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_CHICKEN, animalsHUD, animalsHUD.ShowChicken, false, true, false, true); --, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowChicken] ~= nil then 
					g_inputBinding.events[eventShowChicken].displayIsVisible = false 
				end 

				local _2, eventShowCows = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_COWS, animalsHUD, animalsHUD.ShowCows, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowCows] ~= nil then 
					g_inputBinding.events[eventShowCows].displayIsVisible = false 
				end 

				local _3, eventShowPigs = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_PIGS, animalsHUD, animalsHUD.ShowPigs, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowPigs] ~= nil then 
					g_inputBinding.events[eventShowPigs].displayIsVisible = false 
				end 

				local _4, eventShowHorses = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_HORSES, animalsHUD, animalsHUD.ShowHorses, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowHorses] ~= nil then 
					g_inputBinding.events[eventShowHorses].displayIsVisible = false 
				end    

				local _5, eventShowSheeps = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_SHEEPS, animalsHUD, animalsHUD.ShowSheeps, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowSheeps] ~= nil then 
					g_inputBinding.events[eventShowSheeps].displayIsVisible = false 
				end 

				local _6, eventFontSizeIncrease = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_FONT_INCREASE, animalsHUD, animalsHUD.FontSizeIncrease, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventFontSizeIncrease] ~= nil then 
					g_inputBinding.events[eventFontSizeIncrease].displayIsVisible = false 
				end 

				local _7, eventFontSizeDecrease = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_FONT_DECREASE, animalsHUD, animalsHUD.FontSizeDecrease, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventFontSizeDecrease] ~= nil then 
					g_inputBinding.events[eventFontSizeDecrease].displayIsVisible = false 
				end 

				local _8, eventShowCombiFiLv = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_COMBI_FILL_LEVEL, animalsHUD, animalsHUD.CombiFiLv, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowCombiFiLv] ~= nil then 
					g_inputBinding.events[eventShowCombiFiLv].displayIsVisible = false 
				end 

				local _9, eventShowHideAllOnHud = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_SHOW_HIDE_ALL, animalsHUD, animalsHUD.ShowHideAllOnHud, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowHideAllOnHud] ~= nil then 
					g_inputBinding.events[eventShowHideAllOnHud].displayIsVisible = false 
				end   

				local _10, eventMinimizeHud = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_MINIMIZE, animalsHUD, animalsHUD.MinimizeHud, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventMinimizeHud] ~= nil then 
					g_inputBinding.events[eventMinimizeHud].displayIsVisible = false 
				end   

				local _11, eventShortHud = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_SHORT, animalsHUD, animalsHUD.ShortHud, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShortHud] ~= nil then 
					g_inputBinding.events[eventShortHud].displayIsVisible = false 
				end   

				local _12, eventPicTypeHud = g_currentMission.inputManager:registerActionEvent(InputAction.A_HUD_PICTYPE, animalsHUD, animalsHUD.PicTypeHud, false, true, false, true); 
				if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventPicTypeHud] ~= nil then 
					g_inputBinding.events[eventPicTypeHud].displayIsVisible = false 
				end   
			else
				inputsActiveHUDs = false
			end;
		end;
	end;
end;

function setColorWhite()
	setTextColor(1,1,1,1);
end;

-- function endet erst GANZ unten !
function animalsHUD:draw()
	-- setting for screen render
	linePadding = fontSize + 0.002;
	setTextColor(1,1,1,1);

	local position_X_StandardCombi = HUD_position_horizontal - 0.0038  -- standard: 0.9862 / - 0.0138
	local position_X_StandardCombiOffsetRight = 0.0785
	local position_X_Standard = HUD_position_horizontal                -- standard: 0.99
	local position_X_StandardOffsetRight = 0.0567

	local position_Y_Standard = HUD_position_vertictal                 -- standard: 0.86

	posY = position_Y_Standard -- all huds have the same start hight

	-- geo location added here -- 
	if g_currentMission.player ~= nil then 
		local x_pos_player,y_pos_player,z_pos_player = g_currentMission.player:getPositionData()
		local x_positionHotspot = 0
		local z_positionHotspot = 0

		locationAnimalsBuildingID = 0

		-- Anzeige nur der Stlle in der Nhe
		BuildingTableIndex = 0
		locationNearBuildingIDTable = {}

		for k,husbandry in pairs(g_currentMission.husbandries) do
			local hotspot = husbandry.mapHotspots[1]

			if hotspot ~= nil then
				-- for k,hotspot in pairs(hotspots) do  

				x_positionHotspot = hotspot.xMapPos
				z_positionHotspot = hotspot.zMapPos

				local distanceBetweenPlayerAndBuilding = math.sqrt(math.pow((x_pos_player - x_positionHotspot),2) + math.pow((z_pos_player - z_positionHotspot),2))

				-- player in radius near barn -> star
				if distanceBetweenPlayerAndBuilding < radius then
					-- id of the building on the map close to the player (radius). 
					locationAnimalsBuildingID = husbandry.id
				end 

				-- player in radiusBarns near barn -> reduced number of displayed huds
				if showNearBarnsOnly == true then
						if distanceBetweenPlayerAndBuilding < radiusBarns then
						-- index starts with 1
						BuildingTableIndex = BuildingTableIndex + 1

						-- id/s of the building/s on the map close to the player (radiusBarns). 
						locationNearBuildingIDTable[BuildingTableIndex] = husbandry.id
					end
				end
			end
		end
	end 

	--check percent and set colors
	function setColorIndicatorForMaxAndMinPercentValues(percent)
		setColorWhite(); -- set all text to white

		if percent ~= nil then
			if percent >= 75 then
				setTextColor(0.1,0.6,0.1,1); -- green dark
				return percent
			elseif percent >= 45 then
				setTextColor(0.4,0.8,0.6,1); -- green light
				return percent
			elseif percent >= 15 then
				setTextColor(0.8,0.8,0.2,1); -- orange
				return percent
			elseif percent < 15 then
				setTextColor(0.8,0.2,0.2,1); -- red
				return percent
			end
		end
	end

	function setCleanLinessColorIndicatorForMaxAndMinPercentValues(percent)
		setColorWhite(); -- set all text to white
		if percent ~= nil then
			if percent >= 95 then
				setTextColor(0.1,0.6,0.1,1); -- green dark
				return percent, tostring("  :-)")

				elseif percent >= 60 then
				setTextColor(0.4,0.8,0.6,1); -- green light
				return percent, tostring("  ok!")

				elseif percent >= 30 then
				setTextColor(0.8,0.8,0.2,1); -- orange
				return percent, tostring("  go!")

				elseif percent < 30 then
				setTextColor(0.8,0.2,0.2,1); -- red
				return percent, tostring("  !!!")
			end
		end
	end

	function setProductionColorIndicatorForMaxAndMinPercentValues(percent)
		setColorWhite(); -- set all text to white

		if percent >= 95 then
		setTextColor(0.1,0.6,0.1,1); -- green dark
		return percent

		elseif percent >= 60 then
		setTextColor(0.4,0.8,0.6,1); -- green light
		return percent

		elseif percent >= 30 then
		setTextColor(0.8,0.8,0.2,1); -- orange
		return percent

		elseif percent < 30 then
		setTextColor(0.8,0.2,0.2,1); -- red
		return percent

		end
	end

	function hudsActiveCount()
		activeHUDs = 0;
		if numberOfHudsActiveOnScreen.animalsChickenHudActive == true then
			activeHUDs = activeHUDs + 1
		end
		if numberOfHudsActiveOnScreen.animalsCowHudActive == true then
			activeHUDs = activeHUDs + 1
		end
		if numberOfHudsActiveOnScreen.animalsPigHudActive == true then
			activeHUDs = activeHUDs + 1
		end 
		if numberOfHudsActiveOnScreen.animalsHorseHudActive == true then
			activeHUDs = activeHUDs + 1
		end  
		if numberOfHudsActiveOnScreen.animalsSheepHudActive == true then
			activeHUDs = activeHUDs + 1
		end 

		-- in Arbeit ...
		-- wenn alle HUDs einzelnd aus sind, dann wird die globale Aus-Funktion deaktiviert
		-- if activeHUDs == 0 then
		--	hideAllOnHudActive = true
		-- end

		return active
	end

	-------------------------------------------------
	-- draw the animals infos on the screen. 
	-------------------------------------------------

	local playerNamePosX = 0.0
	local playerNamePosY = 0.0

	function drawPlayerOnHud(nameOfPlayer)
		setTextBold(true);
		setTextColor(1,0.9,0.4,1); 
		setTextAlignment(RenderText.ALIGN_LEFT);  

		-- Stern statt tostring(nameOfPlayer)
		-- renderText(playerNamePosX, playerNamePosY, fontSize, tostring(nameOfPlayer))
		if nameOfPlayer ~= "" then
			renderText(playerNamePosX, playerNamePosY, 1.6 * fontSize, "*")
		end;
	end

	function drawInfo(title,firstValueToDraw,secondValueToDraw,thirdValueToDraw,fourthValueToDraw,valueForPadding,starmark,textgrey)
		local dyn_dist_minimize = 0;
		local dyn_dist_minimize2 = 0;

		if minimizeHudActive == true then
			-- ORIGINAL (OHNE DYNAMISCHE BREITE)
			-- dyn_dist_minimize = 0.05
			-- DYNAMISCHE BREITE
			dyn_dist_minimize = 2 * (2.75 * fontSize)
			-- Abstand 2. Spalte wegen Textkollision kuenstlich etwas vergroessern
			dyn_dist_minimize2 = (2 * (fontSize - fontSizeMin))
		end

		-- ORIGINAL (OHNE DYNAMISCHE BREITE)
		-- if combiFiLvActive == true then
		-- 	posX = position_X_StandardCombi + dyn_dist_minimize;
		-- 	posX2 = posX + position_X_StandardCombiOffsetRight;
		-- 	posX3 = posX + position_X_StandardCombiOffsetRight + 0.025;
		-- 	posX4 = posX + position_X_StandardCombiOffsetRight + 0.05;
		-- else 
		-- 	posX = position_X_Standard + dyn_dist_minimize + 0.15 - (15 * fontSize);
		-- 	posX2 = posX + position_X_StandardOffsetRight;
		-- 	posX3 = posX + position_X_StandardOffsetRight + 0.025;
		-- 	posX4 = posX + position_X_StandardOffsetRight + 0.05;
		-- end 

		-- DYNAMISCHE BREITE
		-- die Abstaende und Faktoren sind fuer die DEUTSCHEN Texte optimiert - fuer andere Sprachen muss das ggf. angepasst werden
		-- the distances and factors are optimized for the GERMAN texts - for other languages it maybe has to be adjusted
		if combiFiLvActive == true then
			posX = position_X_StandardCombi + dyn_dist_minimize - (18 * fontSize)
			posX2 = posX + position_X_StandardCombiOffsetRight - (12 * fontSizeMin) + (12 * fontSize)
			posX3 = posX2 + (2.75 * fontSize)
			posX4 = posX3 + (2.75 * fontSize)
		else 
			posX = position_X_Standard + dyn_dist_minimize - dyn_dist_minimize2 - (15 * fontSize)
			posX2 = posX + position_X_StandardOffsetRight + dyn_dist_minimize2 - (9 * fontSizeMin) + (9 * fontSize)
			posX3 = posX2 + (2.75 * fontSize)
			posX4 = posX3 + (2.75 * fontSize)
		end

		-- check if the title is an animal name
		-- if not do no bold text and white text color
		if title ~=nil then
			if title == language.animals.huehnerbestand or title == language.animals.kuhbestand or title == language.animals.schweinebestand or title == language.animals.pferdebestand or title == language.animals.schafebestand then
				setTextBold(true)
				setTextColor(0.2,0.8,0.8,1) -- tuerkis
			else
				setTextBold(false)
				setColorWhite()
			end
		end

		setTextAlignment(RenderText.ALIGN_LEFT)
		posY = posY - valueForPadding;

		if title~=nil and firstValueToDraw ~=nil then
			setTextAlignment(RenderText.ALIGN_LEFT)

			--set playernameLocation on the correct position where is player close to animals. draw the name left from it on hud
			-- font-Size 0.012 (grosse Schrift) wirkungslos, bei font-Size 0.006 (kleine Schrift) ist der Wert 0.0012
			-- die Absolutwerte hinten sind die Standardpositionen bei grter Schrift
			playerNamePosX = posX + (0.25 * (0.012 - fontSize)) - 0.0070
			playerNamePosY = posY + (0.60 * (0.012 - fontSize)) - 0.0058

			renderText(posX, posY, fontSize, title) -- first item -- RENDER THE TITLE WITH ALIGNMENT LEFT. EXAMPLE "WHEAT: or Count of Animals"
			setTextAlignment(RenderText.ALIGN_RIGHT);

			-- CHECK IF A ANIMAL OR FRUIT
			-- NUMBER = FRUIT
			if secondValueToDraw ~= "" then
				-- check if cleanliness or production 

				-- render the cleanliness text with color on the hud
				if title == language.animals.sauberkeit then
					local _,warningMessageWithColor = setCleanLinessColorIndicatorForMaxAndMinPercentValues(firstValueToDraw)
					-- alt
					-- renderText(posX2, posY, fontSize, "" .. tostring(firstValueToDraw).."%" .. " " .. tostring(warningMessageWithColor))
					renderText(posX2, posY, fontSize, "" .. tostring(firstValueToDraw).." %")
				-- render the production text with color on the hud 
				elseif title == language.animals.produktivitaet then
					local warningMessageWithColorOfProduction = setProductionColorIndicatorForMaxAndMinPercentValues(firstValueToDraw)
					renderText(posX2, posY, fontSize, "" .. tostring(warningMessageWithColorOfProduction).." %")
				else
					-- if the title not cleanliness or production then special for only liters or kgs
					local textcol2 = "";
					if secondValueToDraw == "showValueWithLiters" or secondValueToDraw == "showValueWithKg" or secondValueToDraw == "showValueWithStk" or secondValueToDraw == "showValueWithNothing" then
						-- for all productions from animals in l or kg
						if secondValueToDraw == "showValueWithKg" then
							textcol2 = " kg"
						elseif secondValueToDraw == "showValueWithLiters" then 
							textcol2 = " l"
						elseif secondValueToDraw == "showValueWithStk" then 
							textcol2 = " Stk"
						else 
							-- for all productions from animals in WITHOUT Liters or KGs (eggs and wools)
							textcol2 = "" 
						end
						renderText(posX2, posY, fontSize, tostring(firstValueToDraw) .. textcol2)
					else
						-- for all other fruits that can gives liters and percent 
						local secondValueWithColorWarning = setColorIndicatorForMaxAndMinPercentValues(secondValueToDraw)

						-- zweite Spalte - inkl. manueller Korrektur
						if secondValueWithColorWarning == 101 then
							secondValueWithColorWarning = 100
						end
						renderText(posX2, posY, fontSize, "" .. tostring(firstValueToDraw).." l" .. " / " .. tostring(secondValueWithColorWarning).." %")
				
						-- dritte Spalte
						setTextColor(0.5,0.5,0.5,1); -- grau
						if minimizeHudActive == true then
							renderText(posX3, posY, fontSize, "")
						else
							local starmarktxt = ""
							if starmark == 1 then
								starmarktxt = "* "
							end

							renderText(posX3, posY, fontSize, "" .. starmarktxt .. tostring(thirdValueToDraw).." l")
						end

						-- vierte Spalte - inkl. manueller Korrektur - Anzeige erst wenn fourth(Nachfuell) > 10% von third(Gesamtkapazitaet)
						-- if fourthValueToDraw == -1 then
						-- 	fourthValueToDraw = 0
						-- end
						if fourthValueToDraw < 0.1 * thirdValueToDraw then
							-- da machste nix - DOCH, SCHWACHE FARBE
							setTextColor(0.2,0.2,0.2,1); -- hellgrau
						else
							-- alle orange
							-- setTextColor(0.8,0.8,0.2,1); -- orange

							-- Farbe wie Spalte 2
							setColorIndicatorForMaxAndMinPercentValues(secondValueToDraw)
						end

						if minimizeHudActive == true then
							renderText(posX4, posY, fontSize, "")
						else
							renderText(posX4, posY, fontSize, "" .. tostring(fourthValueToDraw).." l")
						end
					end 
				end
			else
				-- if the secondValueToDraw empty continue here. 
				-- set all other fonts to color white
				setTextBold(false)
				setColorWhite()
				if minimizeHudActive == true then
					setTextColor(0.6,0.2,0.6,1) -- violett
					if textgrey == 1 then
						setTextColor(0.7,0.7,0.7,1) -- violett
					end
				end
				renderText(posX2, posY, fontSize, "" .. tostring(firstValueToDraw))  -- only for animals count render

				-- setTextColor(0.2,0.8,0.8,1); -- blue
				-- renderText(posX3, posY, fontSize, "" .. tostring(thirdValueToDraw))
				setTextColor(0.6,0.2,0.6,1) -- violett
				if textgrey == 1 then
					setTextColor(0.7,0.7,0.7,1) -- violett
				end
				renderText(posX4, posY, fontSize, "" .. tostring(fourthValueToDraw))
			end
		end
	end

	-- get global food from animals
	function getFiLvFoodFromId(id, husbandry)
		if id ~=nil and husbandry ~=nil then
			--loop for fillCapacity Food
			local capacities = husbandry.modulesByName.food.foodGroupCapacities
			local capacity = 0;
			
			for k,v in pairs(capacities) do  
				capacity = capacities[k].capacity;
			end
			-- 1. Berechnung fuer weitere Berechnung - extra ceil fuer 100% statt 99,9% !
			local FiLvFood = tonumber(math.ceil(husbandry.modulesByName.food.fillLevels[id]));
			-- Berechnung mit Nachkommawert
			local FiLvFoodPercent = tonumber(math.floor((FiLvFood / capacity) * decimalPlacesFactor1))/decimalPlacesFactor2;

			-- erneute Berechnung - extra floor
			local FiLvFood = tonumber(math.floor(husbandry.modulesByName.food.fillLevels[id]));
			
			return FiLvFood,FiLvFoodPercent,capacity;
		else
			print("Fehler mit getFiLvFoodFromId ID (".. id ..") und husbandry (".. husbandry .. ")")
		end
	end

	-- get water from animals
	function getFiLvWaterFromId(id, husbandry)
		 if id ~=nil and husbandry ~=nil then 
		 --loop for fillCapacity Water
			 if husbandry.modulesByName.water ~= nil then
				local capacity = husbandry.modulesByName.water.fillCapacity

				-- 1. Berechnung fuer weitere Berechnung - extra ceil fuer 100% statt 99,9% !
				local FiLvWater = tonumber(math.ceil(husbandry.modulesByName.water.fillLevels[id]));
				local FiLvWaterPercent = tonumber(math.floor((FiLvWater / capacity) * decimalPlacesFactor1))/decimalPlacesFactor2;

				-- erneute Berechnung mit Nachkommawert - extra floor
				local FiLvWater = tonumber(math.floor(husbandry.modulesByName.water.fillLevels[id]));

				return FiLvWater,FiLvWaterPercent,capacity;
			else 
				-- if no moddules with water available
				return nil, nil, nil;
			end
		 else
		print("Fehler mit getFiLvWaterFromId ID (".. id ..") und husbandry (".. husbandry .. ")")
	  end
	end

	-- get straw from animals
	function getFiLvStrawFromId(id, husbandry)
		if id ~=nil and husbandry ~=nil then 
			--loop for fillCapacity Straw
			local capacity = husbandry.modulesByName.straw.fillCapacity

			-- 1. Berechnung fuer weitere Berechnung - extra ceil fuer 100% statt 99,9% !
			local FiLvStraw = tonumber(math.ceil(husbandry.modulesByName.straw.fillLevels[id]));
			local FiLvStrawPercent = tonumber(math.floor((FiLvStraw / capacity) * decimalPlacesFactor1))/decimalPlacesFactor2;

			-- erneute Berechnung mit Nachkommawert - extra floor
			local FiLvStraw = tonumber(math.floor(husbandry.modulesByName.straw.fillLevels[id]));

			return FiLvStraw,FiLvStrawPercent,capacity;
		else
			print("Fehler mit getFiLvStrawFromId ID (".. id ..") und husbandry (".. husbandry .. ")")
		end
	end

	-- get milk from cows
	function getFiLvMilkFromId(id, husbandry)
		if id ~=nil and husbandry ~=nil then 
		 --loop for fillCapacity Straw
	   --  local capacity = husbandry.modulesByName.milk.fillCapacity
		 local FiLvMilk = tonumber(math.floor(husbandry.modulesByName.milk.fillLevels[id]));
		--- local FiLvMilkPercent = tonumber(math.ceil((100 * FiLvMilk / capacity)));
		
		return FiLvMilk --, FiLvMilkPercent;
		else
		print("Fehler mit getFiLvMilkFromId ID (".. id ..") und husbandry (".. husbandry .. ")")
	  end
	end

	-- get manure from cows, pigs
	function getFiLvManureFromId(id, husbandry)
		if id ~=nil and husbandry ~=nil then 
		 --loop for fillCapacity Straw
		 --local capacity = husbandry.modulesByName.manure.fillCapacity
		 local FiLvManure = tonumber(math.floor(husbandry.modulesByName.manure.fillLevels[id]));
		-- local FiLvManurePercent = tonumber(math.ceil((100 * FiLvManure / capacity)));
		
		return FiLvManure ---, FiLvManurePercent;
		else
		print("Fehler mit getFiLvManureFromId ID (".. id ..") und husbandry (".. husbandry .. ")")
	  end
	end

	-- get liquid manure from cows, pigs
	function getFiLvLiquidManureFromId(id, husbandry)
		if id ~=nil and husbandry ~=nil then 
		 --loop for fillCapacity Straw
		 --local capacity = husbandry.modulesByName.liquidManure.fillCapacity
		 local FiLvLiquidManure = tonumber(math.floor(husbandry.modulesByName.liquidManure.fillLevels[id]));
		 --local FiLvLiquidManurePercent = tonumber(math.ceil((100 * FiLvLiquidManure / capacity)));
		
		return FiLvLiquidManure --, FiLvLiquidManurePercent;
		else
		print("Fehler mit ID (".. id ..") und husbandry (".. husbandry .. ")")
	  end
	end

	-- get pallets from chicken eggs, sheep wool
	function getFiLvPallets(husbandry)
		if husbandry ~=nil then 
		 --loop for FiLv Pallets
		 --count the fillLevels. (bug on giants)!?! gives sometimes nil back. try to fix here and get correct vales to user UD.
		 -- getFiLvPallets(husbandry) == -- no 2nd parameter due the bug from giants.. !!
		 local fillLevels = husbandry.modulesByName.pallets.fillLevels;
		 
		 local level_1 = fillLevels[1]
		
		 if level_1 then 
		
		   return tonumber(math.floor(level_1))
		 else 
		   return 0 
		  end 
	  end
	end

	function getCleanlinessFactorInPercent(husbandry)
		if husbandry.modulesByName.foodSpillage ~= nil then
		local cleanPercent = tonumber(math.floor(husbandry.modulesByName.foodSpillage.cleanlinessFactor * decimalPlacesFactor1))/decimalPlacesFactor2
		return cleanPercent
	  else
		print("Fehler mit getCleanlinessFactorInPercent husbandry (".. husbandry .. ")")
		return 0
	  end
	end

	function getProductionFactorInPercent(husbandry)
		if husbandry.globalProductionFactor ~= nil then
		local productionPercent = tonumber(math.floor(husbandry.globalProductionFactor * decimalPlacesFactor1))/decimalPlacesFactor2
		return productionPercent
	   else
		 print("Fehler mit getProductionFactorInPercent husbandry (".. husbandry .. ")")
		return 0
	  end
	end

	function countAnimals(husbandry)
		if husbandry ~= nil then
			local numberOfAnimalsChicken = 0;
			for k,v in pairs(husbandry.modulesByName.animals.animals) do
				numberOfAnimalsChicken = tonumber(k)
			end
			return numberOfAnimalsChicken
		else
			print("Fehler mit countAnimals husbandry (".. husbandry .. ")")
			return 0
		end
	end

	-- check where is the owner of every single husbandries.
	farmData = {
	  ownerFarmId = 0,
	  farmId = 0, 
	}

	local playerIsOwnerOfFarm = false

	function checkisOwnerOfFarm(husbandry)
		if g_currentMission:getIsClient() then
			farmData.ownerFarmID = g_currentMission.player.ownerFarmId
			farmData.farmId = g_currentMission.player.farmId

			if husbandry.modulesByName.animals.owner.ownerFarmId == farmData.farmId then
				playerIsOwnerOfFarm = true
				return true
			else 
				playerIsOwnerOfFarm = false
				return false
			end
		end
	end 

	function createOverlayForAnimalsHUD(thisAnimalName,rowcnt,bgflag,thisNumberOfAnimals)
		local littleBorder = 0.004
		local posXlittle = 0
		local posXlittle2 = 0
		local posYlittle = 0
		local posYlittleCorr = 0
		local posYlittleCorrFont = 0
		local distAfterTitleProd = 0

		-- Hoehenberechnung
		local distrows = (linePadding * rowcnt) + littleBorder;

		-- color of backgrounds - switching or stable or none
		-- backgroundColorConfig = 0 means automatically swiching backgrounds
		if backgroundColorConfig == 1 then
			bgflag = 1
		elseif backgroundColorConfig == 2 then
			bgflag = 2
		elseif backgroundColorConfig == 3 then
			bgflag = 3
		elseif backgroundColorConfig == 4 then
			bgflag = 4
		elseif backgroundColorConfig == 5 then
			bgflag = 5
		end

		if animalsHUD.overlay[thisAnimalName] == nil then
			animalsHUD.overlay[thisAnimalName] = createImageOverlay(animalsHUD.modDirectory .. "backgrounds/overlay_bg" .. bgflag .. ".dds");

			setOverlayColor(animalsHUD.overlay[thisAnimalName],1,1,1,backgroundTransparency)
		end

		-- maybe NO backgrounds
		if backgroundColorConfig >= 0 then
			posXlittle = posX - littleBorder
			posXlittle2 = posX + littleBorder
			posYlittle = posY - littleBorder

			-- Hoehenkorrektur - einfach (unter Titel) oder doppelt (unter Titel + Produktivitaet)
			-- bei den Pferde und leeren Stllen immer einfach, da keine verkuerzte Darstellung moeglich
			if shortHudActive == true or thisAnimalName == "horse" or thisNumberOfAnimals < 1 then
				distAfterTitleProd = (distAfterTitleFactor - 1) * linePadding
			else
				distAfterTitleProd = 2 * ((distAfterTitleFactor - 1) * linePadding)
			end

			posYlittleCorr = distrows - (linePadding + littleBorder) + distAfterTitleProd 

			-- Hoehenkorrektur ganz hinten: font-Size 0.012 (grosse Schrift) wirkungslos, bei font-Size 0.006 (kleine Schrift) ist der Wert 0.0012
			-- der Absolutwert hinten vergroessert den Titelzeilenbackground etwas nach unten
			posYlittleCorrFont = (0.3 * (0.012 - fontSize)) - 0.0010

			if thisNumberOfAnimals > 0 then
				renderOverlay(animalsHUD.overlay[thisAnimalName],posXlittle,posYlittle,1 - posXlittle2 - (0.99 - HUD_position_horizontal),distrows + 0.0015 + distAfterTitleProd);
			end

				-- Titelzeile doppelt
			if thisNumberOfAnimals > 0 then
				renderOverlay(animalsHUD.overlay[thisAnimalName],posXlittle,posYlittle + posYlittleCorr + posYlittleCorrFont,1 - posXlittle2 - (0.99 - HUD_position_horizontal),linePadding + littleBorder + 0.0015 - posYlittleCorrFont);
			else
				-- hier: leerer / neuer Stall) - Korrektur posY um '- (0.25 * linePadding)' (nicht berechnet, sondern nach Optik)
				renderOverlay(animalsHUD.overlay[thisAnimalName],posXlittle,posYlittle + posYlittleCorr + posYlittleCorrFont - (0.25 * linePadding),1 - posXlittle2 - (0.99 - HUD_position_horizontal),linePadding + littleBorder + 0.0015 - posYlittleCorrFont);
				renderOverlay(animalsHUD.overlay[thisAnimalName],posXlittle,posYlittle + posYlittleCorr + posYlittleCorrFont - (0.25 * linePadding),1 - posXlittle2 - (0.99 - HUD_position_horizontal),linePadding + littleBorder + 0.0015 - posYlittleCorrFont);
			end
		end

		-- Tierbilder
		-- bei Bildtyp 0 (keine Anzeige) oder Tierzahl -1 (Entfernung zu gro) werden die Bilder gar nicht angzeigt
		if animalPicType ~= 0 then
			-- overlay muss jedes mal erzeugt werden wegen Tierbildwechsel
			-- if animalsHUD.overlay2[thisAnimalName] == nil then
			animalsHUD.overlay2[thisAnimalName] = createImageOverlay(animalsHUD.modDirectory .. "animals/" .. animalPicFolder .. "/overlay_" .. thisAnimalName .. ".dds");
			-- bei animalPicRound = 1 -> 100% Transparenz, bei animalPicRound = 2 -> xx% Transparenz
			setOverlayColor(animalsHUD.overlay2[thisAnimalName],1,1,1,1 + (1 * (1 - animalPicTransp)) - (animalPicRound * (1 - animalPicTransp)))
			-- end

			-- Berechnung, um die Bilder nicht im Monitorformat, sondern quadratisch darzustellen
			-- wie self.overlay.scaleWidth verwenden ??? animalsHUD.overlay2[thisAnimalName].overlay.scaleWidth ???
			local pixelWidthCalc = g_aspectScaleX / g_referenceScreenWidth
			-- wie self.overlay.scaleHeight verwenden ??? animalsHUD.overlay2[thisAnimalName].overlay.scaleHeight ??? 
			local pixelHeightCalc = g_aspectScaleY / g_referenceScreenHeight

			-- Tierbilder derzeit 128px x 128px gross
			local animalPicWidthSource = 128
			local animalPicHeightSource = 128
			-- Anzeige dynamisch mit der fontSize
			local animalPicSizeFactor = (50 * fontSize) - 0.1 -- also bei font-Size 0.006 bis 0.012 zwischen 0.3 und 0.6 abzgl. 0.1 => Faktor 0.2 bis 0.5
			local animalPicWidthCalc  = animalPicSizeFactor * animalPicWidthSource * pixelWidthCalc
			local animalPicHeightCalc = animalPicSizeFactor * animalPicHeightSource * pixelHeightCalc

			-- renderOverlay(animalsHUD.overlay2[thisAnimalName],posX-animalPicWidthCalc-(2*littleBorder),posY+distrows-animalPicHeightCalc-littleBorder,animalPicWidthCalc,animalPicHeightCalc);
			if thisNumberOfAnimals > 0 then
				renderOverlay(animalsHUD.overlay2[thisAnimalName],posX - animalPicWidthCalc - (2 * littleBorder),posYlittle + posYlittleCorr + linePadding - animalPicHeightCalc,animalPicWidthCalc,animalPicHeightCalc)
			else
				-- halbe Groesse bei zu groer Entfernung und leerem Stall
				renderOverlay(animalsHUD.overlay2[thisAnimalName],posX - (0.5 * animalPicWidthCalc) - (2 * littleBorder),posYlittle + posYlittleCorr + linePadding - (0.5 * animalPicHeightCalc),animalPicWidthCalc/2,animalPicHeightCalc/2)
			end
		end
	end

	 -- buildingIDFromAnimals // 
	 -- draws player name near the hud on the screen if the player entered the zone
	function drawPlayerNameWithLocationOfCurrentBuildingID(husbandry)
		
		local idCurrentBuilding = 0
		local playerName = ""
		local playerLocationBuildingId = locationAnimalsBuildingID
		

		if husbandry ~= nil then
		   idCurrentBuilding = husbandry.id
	   
		   if playerLocationBuildingId == idCurrentBuilding then
				playerName = g_currentMission.player.visualInformation.playerName
				 return tostring("[" .. playerName .. "]")
			   else
				return tostring("")
			end
		else
			return tostring("")
		end
	end

	-- Test auf Aktivierung von Seasons und MoreBunkerSilo
	function checkSelectedMods()
		local selectedMods = {};

		if self.isServer then
			selectedMods = g_modSelectionScreen.missionDynamicInfo.mods;
		else
			selectedMods = g_mpLoadingScreen.missionDynamicInfo.mods;
		end;
		
		for _, mod in pairs(selectedMods) do
			local modName = mod.modName;

			-- bei voller Ausgabe im log.txt
			if searchLogTxtFlag == 2 then
				local modDir = mod.modDir;
				print("modName: " .. modName .. " / modDir: " .. modDir)
			end

			if modName == "FS19_RM_Seasons" then
				-- Seasons Mod ist AKTIV
				SeasonsIsActive = true;
			end

			if modName == "FS19_MoreBunkersilo" then
				-- MoreBunkerSiloIsActive Mod ist AKTIV
				MoreBunkerSiloIsActive = true;
			end
		end
	end

	-- is val content of checkTable
	function tabContVal(checkTable, val)
	   for i = 1,#checkTable do
		  if checkTable[i] == val then 
			 return true
		  end
	   end
	   return false
	end

	-- Startfunktionen, Suche nach den IDs von CCM und Grassilage (Mod: MoreBunkerSilo)
	function getMBSdynamicIDs()
		local searchIDFlLv = 0
		local stdFoodIDsnotGRSIL = {}
		local stdFoodIDsnotCCM = {}
		local deactivateIDMeasurement = 0

		if searchLogTxtFlag > 0 then
			print("---")
			if searchFlagDynID == 0 then
				print(g_i18n:getText("msg_welcome"))
				if showNearBarnsOnly == true then
					print(g_i18n:getText("msg_near_barns_note1") .. radiusBarns .. g_i18n:getText("msg_near_barns_note2"))
				end
				print("---")
			else
				print(g_i18n:getText("msg_recalculation"));
			end
		end

		-- Auslesen der IDs fuer CCM und Grassilage
		-- moegliches Problem: die Messung erfolgt erst, wenn mindestens ein Schweinestall / Kuhstall / Schafstall existiert ...

		deactivateIDMeasurement = 0
		varID_ccm = 0
		varID_grassilage = 0

		-- IMPORTANT: if the ID measurement - for whatever reason - fails these three values can be harcoded here
		-- deactivateIDMeasurement = 1
		-- varID_ccm = 84          -- this is an EXMAPLE, you have to set the correct value for your game
		-- varID_grassilage = 86   -- this is an EXMAPLE, you have to set the correct value for your game

		if deactivateIDMeasurement == 0 then
			for _,husbandry in pairs(g_currentMission.husbandries) do

				-- Grassilage -> COW oder SHEEP
				-- die erste gefundene Tierart wird verwendet, mit IDfoundFlagGRSIL wird eine weitere Suche verhindert
				if husbandry.modulesByName.animals.animalType == "COW" or husbandry.modulesByName.animals.animalType == "SHEEP" then
					if IDfoundFlagGRSIL == 0 then
						searchIDFlLv = 0
						-- Suche von ID = 1 bis 99
						for searchIDNum = 1,99,1 do
							searchIDFlLv = husbandry.modulesByName.food.fillLevels[searchIDNum] 
							if searchIDFlLv ~= nil then
								if searchLogTxtFlag > 1 then
									print ("Animal type: " .. husbandry.modulesByName.animals.animalType .. " / ID: " .. searchIDNum .. " / FillLevel: " .. searchIDFlLv)
								end

								if husbandry.modulesByName.animals.animalType == "COW" then
									-- COW: ID darf nicht 19, 24, 28 oder 30 sein (das sind die Standardfuttersorten)
									stdFoodIDsnotGRSIL = {19,24,28,30}
								end

								if husbandry.modulesByName.animals.animalType == "SHEEP" then
									-- SHEEP: ID darf nicht 28 oder 30 sein (das sind die Standardfuttersorten)
									stdFoodIDsnotGRSIL = {28,30}
								end

								
								if tabContVal(stdFoodIDsnotGRSIL, searchIDNum) then
									-- searchIDNum ist Standardfuttersorte -> NIX MACHEN
								else
									varID_grassilage  = searchIDNum
									-- print("ID for Grassilage found: " .. searchIDNum .. " :-)")

									-- Suche erfolgt beim Programmstart nur EINMAL
									IDfoundFlagGRSIL = 1
								end
							end
						end
						if searchLogTxtFlag > 1 then
							print("---")
						end
					end
				end

				-- CCM -> PIG
				if husbandry.modulesByName.animals.animalType == "PIG" then
					if IDfoundFlagCCM == 0 then
						searchIDFlLv = 0
						-- Suche von ID = 1 bis 99
						for searchIDNum = 1,99,1 do
							searchIDFlLv = husbandry.modulesByName.food.fillLevels[searchIDNum] 
							if searchIDFlLv ~= nil then
								if searchLogTxtFlag > 1 then
									print ("Animal type: " .. husbandry.modulesByName.animals.animalType .. " / ID: " .. searchIDNum .. " / FillLevel: " .. searchIDFlLv)
								end

								-- PIG: ID darf nicht 2, 3, 5, 6, 7, 8, 9 oder 10 sein (das sind die Standardfuttersorten)
								-- Hinweis: Futter mit 9 (Kartoffeln) und 10 (Zuckerrueben) werden von Seasons deaktiviert
								stdFoodIDsnotCCM = {2,3,5,6,7,8,9,10}
								if tabContVal(stdFoodIDsnotCCM, searchIDNum) then
									-- searchIDNum ist Standardfuttersorte -> NIX MACHEN
								else
									varID_ccm = searchIDNum
									-- print("ID for CCM found: " .. searchIDNum .. " :-)")

									-- Suche erfolgt beim Programmstart nur EINMAL
									IDfoundFlagCCM = 1
								end
							end
						end
						if searchLogTxtFlag > 1 then
							print("---")
						end
					end
				end
			end
		end

		-- finale Ergebnis (Status der beiden Mods und die Angabe der IDs von MoreBunkerSilo (MBS)
		local SeasonsIsActiveTXT = g_i18n:getText("word_NOT_ACTIVE")
		local MBSIsActiveTXT = g_i18n:getText("word_NOT_ACTIVE")
		local varID_grassilageTXT = g_i18n:getText("word_YET_UNKNOWN")
		local varID_ccmTXT = g_i18n:getText("word_YET_UNKNOWN")

		if SeasonsIsActive == true then
			SeasonsIsActiveTXT = g_i18n:getText("word_ACTIVE")
		end

		if MoreBunkerSiloIsActive == true then
			MBSIsActiveTXT = g_i18n:getText("word_ACTIVE")
		end

		if IDfoundFlagGRSIL == 1 then
			varID_grassilageTXT = tostring(varID_grassilage)
		end

		if IDfoundFlagCCM == 1 then
			varID_ccmTXT = tostring(varID_ccm)
		end

		if searchLogTxtFlag > 0 then
			if searchFlagDynID == 0 then
				print(g_i18n:getText("msg_affecting_mods1") .. SeasonsIsActiveTXT .. g_i18n:getText("msg_affecting_mods2") .. MBSIsActiveTXT .. g_i18n:getText("msg_affecting_mods3"));
				if SeasonsIsActive == true then
					print(g_i18n:getText("msg_seasons_mod_true"))
				else
					print(g_i18n:getText("msg_seasons_mod_false"))
				end
				if MoreBunkerSiloIsActive == true then
					print(g_i18n:getText("msg_mbs_mod_true"))
				else
					print(g_i18n:getText("msg_mbs_mod_false"))
				end
			end

			if MoreBunkerSiloIsActive == true then
				print(g_i18n:getText("msg_search_result1") .. varID_grassilageTXT .. g_i18n:getText("msg_search_result2") .. varID_ccmTXT)
				if IDfoundFlagGRSIL == 0 or IDfoundFlagCCM == 0 then
					print(g_i18n:getText("msg_recalculation_later"))
				end
				print("---")
			end
		end
	end
	
	-- einmaliger Aufruf der Startfunktionen bei Programmstart
	if searchFlagDynID == 0 then
		-- Suche nach Seasons / MoreBunkerSilo
		checkSelectedMods()

		-- ID-Berechnung
		getMBSdynamicIDs()

		searchFlagDynID = 2
	end

	if hideAllOnHudActive == false then
		local fruitsFiLv = 0
		local fruitsFiLvPct = 0
		local fruitsCpty = 0

		-- CHICKEN
		if animalsChickenHudActive == true then
			local stallnummer = 0;
			local stallzaehler = 0;
			for _,husbandry in pairs(g_currentMission.husbandries) do
				local rowcounter = 0;

				if checkisOwnerOfFarm(husbandry) == true then 
					stallnummer = stallnummer + 1;

					if husbandry.modulesByName.animals.animalType == "CHICKEN" then
						stallzaehler = stallzaehler + 1;
						local numberOfAnimals = countAnimals(husbandry);
						local playerName = drawPlayerNameWithLocationOfCurrentBuildingID(husbandry);

						local tieretier = " ".. g_i18n:getText("word_animals")
						if numberOfAnimals == 1 then
							tieretier = " ".. g_i18n:getText("word_animal")
						end;

						local dynpadding = 1.72;
						if stallzaehler == 1 then
							dynpadding = 2.15;
						end;

						-- Anzeige nur, wenn Spieler nher als radiusBarns entfernt
						-- locationNearBuildingIDTable[BuildingTableIndex]
						if showNearBarnsOnly == true and not tabContVal(locationNearBuildingIDTable, husbandry.id) then
							-- no chicken barn nearer than radiusBarns
							if minimizeHudActive == true then
								-- drawInfo(language.animals.huehnerbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_distance") .. " > " .. radiusBarns .. "m","","","",tonumber(dynpadding*linePadding),0,1)
								drawInfo(language.animals.huehnerbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,1) 
							else
								-- drawInfo(language.animals.huehnerbestand,"","","",g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_distance") .. " > " .. radiusBarns .. "m",tonumber(dynpadding*linePadding),0,1)
								drawInfo(language.animals.huehnerbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,1) 
							end
							drawPlayerOnHud(playerName);

							rowcounter = rowcounter + 1;
							createOverlayForAnimalsHUD("chicken",rowcounter,1,-1)
						else
							if numberOfAnimals > 0 then
								local cleanliness = getCleanlinessFactorInPercent(husbandry);
								local cleanlinessPercent,cleanlinessText  = setCleanLinessColorIndicatorForMaxAndMinPercentValues(cleanliness)

								local production = getProductionFactorInPercent(husbandry);
								local productionPercent  = setProductionColorIndicatorForMaxAndMinPercentValues(production)

								-- animal pen mod START
								local drawWaterForChicken = false
								local waterFiLv,waterFiLvPct,waterCpty     = getFiLvWaterFromId(varID_water,husbandry)
								if waterFiLv ~= nil and waterFiLvPct ~= nil then 
									drawWaterForChicken = true
								end
								-- animal pen mod END

								local weizenFiLv,weizenFiLvPct,weizenCpty  = getFiLvFoodFromId(varID_wheat,husbandry)
								local gersteFiLv,gersteFiLvPct,gersteCpty  = getFiLvFoodFromId(varID_barley, husbandry)
								local eggsFiLv                             = getFiLvPallets(husbandry) -- no 2nd parameter!!

								if minimizeHudActive == true then
									drawInfo(language.animals.huehnerbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,0) 
								else
									drawInfo(language.animals.huehnerbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,0) 
								end
								drawPlayerOnHud(playerName);

								if shortHudActive == true then
									-- nicht anzeigen
									rowcounter = rowcounter - 2;
								else
									drawInfo(language.animals.eier,eggsFiLv,"showValueWithNothing",nil,nil,tonumber(distAfterTitleFactor*linePadding),0,0)
									drawInfo(language.animals.produktivitaet,productionPercent,nil,nil,nil,tonumber(linePadding),0,0)
								end

								drawInfo(language.animals.sauberkeit,cleanlinessPercent,cleanlinessText,nil,nil,tonumber(distAfterTitleFactor*linePadding),0,0) 

								if drawWaterForChicken == true then
									-- Stall ist placable - Seasons baut hier Wasser ein
									drawInfo(language.fruits.wasser,waterFiLv,waterFiLvPct,math.floor(waterCpty),math.floor(waterCpty-waterFiLv),tonumber(linePadding),0,0)
								else
									-- Stall fest verbaut - Seasons baut hier kein Wasser ein
									drawInfo(language.fruits.wasser,"-----","showValueWithNothing","","",tonumber(linePadding),0,0)
								end

								fruitsFiLv = weizenFiLv + gersteFiLv
								fruitsFiLvPct = weizenFiLvPct + gersteFiLvPct
								fruitsCpty = weizenCpty + gersteCpty
								if combiFiLvActive == false then
									-- EIN TROG - Farbgebung nur korrekt bei summierter Prozenztauswertung
									drawInfo(">  " .. language.fruits.weizen,weizenFiLv,fruitsFiLvPct,math.floor(weizenCpty),math.floor(weizenCpty-fruitsFiLv),tonumber(linePadding),0,0)
									drawInfo(">  " .. language.fruits.gerste,gersteFiLv,fruitsFiLvPct,math.floor(gersteCpty),math.floor(gersteCpty-fruitsFiLv),tonumber(linePadding),0,0)
									rowcounter = rowcounter + 7;
								else
									drawInfo(language.fruits.weizen .. " / " .. language.fruits.gerste,fruitsFiLv,fruitsFiLvPct,math.floor(fruitsCpty/2),math.floor((fruitsCpty/2)-fruitsFiLv),tonumber(linePadding),0,0)
									rowcounter = rowcounter + 6;
								end

								-- Test: Berechnungsrate / Anzeige-Wiederholrate -> Durchlauf bei JEDEM FRAME
								-- print ("chicken drawn ...")
							else 
								-- neuer/leerer Stall
								if minimizeHudActive == true then
									drawInfo(language.animals.huehnerbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,0) 
								else
									drawInfo(language.animals.huehnerbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,0) 
								end
								drawPlayerOnHud(playerName);

								rowcounter = rowcounter + 1;
							end
							createOverlayForAnimalsHUD("chicken",rowcounter,1,numberOfAnimals)
						end
					end
				end
			end
		end

		-- COWS
		if animalsCowHudActive == true then
			local stallnummer = 0;
			local stallzaehler = 0;
			for _,husbandry in pairs(g_currentMission.husbandries) do
				local rowcounter = 0;

				if checkisOwnerOfFarm(husbandry) == true then 
					stallnummer = stallnummer + 1;
				
					if husbandry.modulesByName.animals.animalType == "COW" then
						stallzaehler = stallzaehler + 1;
						local numberOfAnimals = countAnimals(husbandry);
						local playerName = drawPlayerNameWithLocationOfCurrentBuildingID(husbandry);

						local tieretier = " ".. g_i18n:getText("word_animals")
						if numberOfAnimals == 1 then
							tieretier = " ".. g_i18n:getText("word_animal")
						end;

						local dynpadding = 1.72;
						if stallzaehler == 1 then
							dynpadding = 2.15;
						end;

						-- Anzeige nur, wenn Spieler nher als radiusBarns entfernt
						-- locationNearBuildingIDTable[BuildingTableIndex]
						if showNearBarnsOnly == true and not tabContVal(locationNearBuildingIDTable, husbandry.id) then
							-- no cow barn nearer than radiusBarns
							if minimizeHudActive == true then
								-- drawInfo(language.animals.kuhbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_distance") .. " > " .. radiusBarns .. "m","","","",tonumber(dynpadding*linePadding),0,1)
								drawInfo(language.animals.kuhbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,1)
							else
								-- drawInfo(language.animals.kuhbestand,"","","",g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_distance") .. " > " .. radiusBarns .. "m",tonumber(dynpadding*linePadding),0,1)
								drawInfo(language.animals.kuhbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,1)
							end
							drawPlayerOnHud(playerName);

							rowcounter = rowcounter + 1;
							createOverlayForAnimalsHUD("cows",rowcounter,2,-1)
						else
							if numberOfAnimals > 0 then
								local cleanliness = getCleanlinessFactorInPercent(husbandry);
								local cleanlinessPercent,cleanlinessText  = setCleanLinessColorIndicatorForMaxAndMinPercentValues(cleanliness)

								local production = getProductionFactorInPercent(husbandry);
								local productionPercent  = setProductionColorIndicatorForMaxAndMinPercentValues(production)

								local waterFiLv,waterFiLvPct,waterCpty                    = getFiLvWaterFromId(varID_water,husbandry)
								local strawFiLv,strawFiLvPct,strawCpty                    = getFiLvStrawFromId(varID_straw,husbandry)

								local grasFiLv,grasFiLvPct,grasCpty                       = getFiLvFoodFromId(varID_grass,husbandry)

								-- Implementierung BUNKERSILO (die beiden neuen Fruechte CCM und Grassilage)
								local grassilageFiLv = 0
								local grassilageFiLvPct = 0
								local grassilageCpty = 0
								-- kein Aufruf, wenn ID unbekannt
								if IDfoundFlagGRSIL == 1 then
									grassilageFiLv,grassilageFiLvPct,grassilageCpty       = getFiLvFoodFromId(varID_grassilage,husbandry)
								end
								
								local mischrationFiLv,mischrationFiLvPct,mischrationCpty  = getFiLvFoodFromId(varID_forage,husbandry)

								local heuFiLv,heuFiLvPct,heuCpty                          = getFiLvFoodFromId(varID_drygrass,husbandry)
								local silageFiLv,silageFiLvPct,silageCpty                 = getFiLvFoodFromId(varID_silage, husbandry)

								local milchFiLv                                           = getFiLvMilkFromId(varID_milk, husbandry)
								local mistFiLv                                            = getFiLvManureFromId(varID_manure, husbandry)
								local guelleFiLv                                          = getFiLvLiquidManureFromId(varID_liquidmanure, husbandry)

								if minimizeHudActive == true then
									drawInfo(language.animals.kuhbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,0) 
								else
									drawInfo(language.animals.kuhbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,0) 
								end
								drawPlayerOnHud(playerName);

								if shortHudActive == true then
									-- nicht anzeigen
									rowcounter = rowcounter - 4;
								else
									if combiFiLvActive == true then
										drawInfo(language.animals.milch .. " / " .. language.animals.mist .. " / " .. language.animals.guelle,milchFiLv .. " / " .. mistFiLv .. " / " .. guelleFiLv,"showValueWithLiters",nil,nil,tonumber(distAfterTitleFactor*linePadding),0,0)
										rowcounter = rowcounter - 2;
									else
										drawInfo(language.animals.milch,milchFiLv,"showValueWithLiters",nil,nil,tonumber(distAfterTitleFactor*linePadding),0,0)  
										drawInfo(language.animals.mist,mistFiLv,"showValueWithLiters",nil,nil,tonumber(linePadding),0,0)  
										drawInfo(language.animals.guelle,guelleFiLv,"showValueWithLiters",nil,nil,tonumber(linePadding),0,0)  
									end

									drawInfo(language.animals.produktivitaet,productionPercent,nil,nil,nil,tonumber(linePadding),0,0)  
								end
								
								drawInfo(language.animals.sauberkeit,cleanlinessPercent,cleanlinessText,nil,nil,tonumber(distAfterTitleFactor*linePadding),0,0) 

								drawInfo(language.fruits.wasser,waterFiLv,waterFiLvPct,math.floor(waterCpty),math.floor(waterCpty-waterFiLv),tonumber(linePadding),0,0)
								drawInfo(language.fruits.stroh,strawFiLv,strawFiLvPct,math.floor(strawCpty),math.floor(strawCpty-strawFiLv),tonumber(linePadding),0,0)
								drawInfo(language.fruits.mischration,mischrationFiLv,mischrationFiLvPct,math.floor(mischrationCpty),math.floor(mischrationCpty-mischrationFiLv),tonumber(linePadding),0,0)
				   
								fruitsFiLv = heuFiLv + silageFiLv
								fruitsFiLvPct = heuFiLvPct + silageFiLvPct
								fruitsCpty = heuCpty + silageCpty
								if combiFiLvActive == false then
									drawInfo(">  " .. language.fruits.heu,heuFiLv,fruitsFiLvPct,math.floor(heuCpty),math.floor(heuCpty-fruitsFiLv),tonumber(linePadding),0,0)
									drawInfo(">  " .. language.fruits.silage,silageFiLv,fruitsFiLvPct,math.floor(silageCpty),math.floor(silageCpty-fruitsFiLv),tonumber(linePadding),0,0)
									rowcounter = rowcounter + 12;
								else 
									drawInfo(language.fruits.heu .. " / " .. language.fruits.silage,fruitsFiLv,fruitsFiLvPct,math.floor(fruitsCpty/2),math.floor((fruitsCpty/2)-fruitsFiLv),tonumber(linePadding),0,0)
									rowcounter = rowcounter + 11;
								end 

								-- wenn MoreBunkerSilo NICHT aktiv
								if MoreBunkerSiloIsActive == false then
									drawInfo("<  " .. language.fruits.gras,grasFiLv,grasFiLvPct,math.floor(grasCpty),math.floor(grasCpty-grasFiLv),tonumber(linePadding),0,0)
								else
									-- Implementierung MOREBUNKERSILO (die beiden neuen Fruechte CCM und Grassilage)
									fruitsFiLv = grasFiLv + grassilageFiLv
									fruitsFiLvPct = grasFiLvPct + grassilageFiLvPct
									fruitsCpty = grasCpty + grassilageCpty
									if combiFiLvActive == false then
										drawInfo("<  " .. language.fruits.gras,grasFiLv,fruitsFiLvPct,math.floor(grasCpty),math.floor(grasCpty-fruitsFiLv),tonumber(linePadding),0,0)
										drawInfo("<  " .. language.fruits.grassilage,grassilageFiLv,fruitsFiLvPct,math.floor(grassilageCpty),math.floor(grassilageCpty-fruitsFiLv),tonumber(linePadding),0,0)
										rowcounter = rowcounter + 1;
									else 
										drawInfo(language.fruits.gras .. " / " .. language.fruits.grassilage,fruitsFiLv,fruitsFiLvPct,math.floor(fruitsCpty/2),math.floor((fruitsCpty/2)-fruitsFiLv),tonumber(linePadding),0,0)
									end 
								end
							else 
								-- neuer/leerer Stall
								if minimizeHudActive == true then
									drawInfo(language.animals.kuhbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,0) 
								else
									drawInfo(language.animals.kuhbestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,0) 
								end
								drawPlayerOnHud(playerName);

								rowcounter = rowcounter + 1;

								-- AUTOMATISCHE Neuberechnung - Aufruf der ID-Messfunktion, notwendig bei Stallkauf KUEHE (oder Schafe)
								if IDfoundFlagGRSIL == 0 and MoreBunkerSiloIsActive == true then
									-- WICHTIG: BEIDE Werte sicherheitshalber neu messen (wie Erstberechnung)
									searchFlagDynID = 1
									IDfoundFlagCCM = 0

									getMBSdynamicIDs()
									searchFlagDynID = 2
								end
							end
							createOverlayForAnimalsHUD("cows",rowcounter,2,numberOfAnimals)
						end
					end
				end
			end
		end

		-- PIGS
		if animalsPigHudActive == true then
			local stallnummer = 0;
			local stallzaehler = 0;
			for _,husbandry in pairs(g_currentMission.husbandries) do
				local rowcounter = 0;

				if checkisOwnerOfFarm(husbandry) == true then 
					stallnummer = stallnummer + 1;

					if husbandry.modulesByName.animals.animalType == "PIG" then
						stallzaehler = stallzaehler + 1;
						local numberOfAnimals = countAnimals(husbandry);
						local playerName = drawPlayerNameWithLocationOfCurrentBuildingID(husbandry);

						local tieretier = " ".. g_i18n:getText("word_animals")
						if numberOfAnimals == 1 then
							tieretier = " ".. g_i18n:getText("word_animal")
						end;

						local dynpadding = 1.72;
						if stallzaehler == 1 then
							dynpadding = 2.15;
						end;

						-- Anzeige nur, wenn Spieler nher als radiusBarns entfernt
						-- locationNearBuildingIDTable[BuildingTableIndex]
						if showNearBarnsOnly == true and not tabContVal(locationNearBuildingIDTable, husbandry.id) then
							-- no pig barn nearer than radiusBarns
							if minimizeHudActive == true then
								-- drawInfo(language.animals.schweinebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_distance") .. " > " .. radiusBarns .. "m","","","",tonumber(dynpadding*linePadding),0,1)
								drawInfo(language.animals.schweinebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,1) 
							else
								-- drawInfo(language.animals.schweinebestand,"","","",g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_distance") .. " > " .. radiusBarns .. "m",tonumber(dynpadding*linePadding),0,1)
								drawInfo(language.animals.schweinebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,1) 
							end
							drawPlayerOnHud(playerName);

							rowcounter = rowcounter + 1;
							createOverlayForAnimalsHUD("pigs",rowcounter,3,-1)
						else
							if numberOfAnimals > 0 then
								local cleanliness = getCleanlinessFactorInPercent(husbandry);
								local cleanlinessPercent,cleanlinessText  = setCleanLinessColorIndicatorForMaxAndMinPercentValues(cleanliness)

								local production = getProductionFactorInPercent(husbandry);
								local productionPercent  = setProductionColorIndicatorForMaxAndMinPercentValues(production)

								local waterFiLv,waterFiLvPct,waterCpty         = getFiLvWaterFromId(varID_water,husbandry)
								local strawFiLv,strawFiLvPct,strawCpty         = getFiLvStrawFromId(varID_straw,husbandry)

								-- VERMUTETER BUG in LS19 oder Seasons
								-- der Futtertrag fuer Mais + CCM ist laut Seasons zb: 500 gross, ausgelesen werden hier aber nur 250 !
								-- man kann den Trog ANGEBLICH bis zu 200% auffuellen
								-- daher wird das hier hart korrigiert (unten bei der Auswertung)

								local maizeFiLv,maizeFiLvPct,maizeCpty         = getFiLvFoodFromId(varID_maize,husbandry)

								-- Implementierung BUNKERSILO (die beiden neuen Fruechte CCM und Grassilage)
								local ccmFiLv = 0
								local ccmFiLvPct = 0
								local ccmCpty = 0
								-- kein Aufruf, wenn ID unbekannt
								if IDfoundFlagCCM == 1 then
									ccmFiLv,ccmFiLvPct,ccmCpty                 = getFiLvFoodFromId(varID_ccm,husbandry)
								end

								local weizenFiLv,weizenFiLvPct,weizenCpty      = getFiLvFoodFromId(varID_wheat,husbandry)
								local gersteFiLv,gersteFiLvPct,gersteCpty      = getFiLvFoodFromId(varID_barley, husbandry)

								local sojaFiLv,sojaFiLvPct,sojaCpty            = getFiLvFoodFromId(varID_soybean,husbandry)
								local rapsFiLv,rapsFiLvPct,rapsCpty            = getFiLvFoodFromId(varID_canola,husbandry)
								local sonnenblumenFiLv,sonnenblumenFiLvPct,sonnenblumenCpty = getFiLvFoodFromId(varID_sunflower,husbandry)

								local kartoFiLv,kartoFiLvPct,kartoCpty     = getFiLvFoodFromId(varID_potato,husbandry)
									local ruebenFiLv,ruebenFiLvPct,ruebenCpty  = getFiLvFoodFromId(varID_sugarbeet,husbandry)

								-- wenn Seasons NICHT aktiv
							--	if SeasonsIsActive == false then
							--		local kartoFiLv,kartoFiLvPct,kartoCpty     = getFiLvFoodFromId(varID_potato,husbandry)
							--		local ruebenFiLv,ruebenFiLvPct,ruebenCpty  = getFiLvFoodFromId(varID_sugarbeet,husbandry)
							--	end

								local mistFiLv                                 = getFiLvManureFromId(varID_manure, husbandry)
								local guelleFiLv                               = getFiLvLiquidManureFromId(varID_liquidmanure, husbandry)

								if minimizeHudActive == true then
									drawInfo(language.animals.schweinebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,0) 
								else
									drawInfo(language.animals.schweinebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,0) 
								end
								drawPlayerOnHud(playerName);

								if shortHudActive == true then
									-- nicht anzeigen
									rowcounter = rowcounter - 3;
								else
									if combiFiLvActive == true then
										drawInfo(language.animals.mist .. " / " .. language.animals.guelle,mistFiLv .. " / " .. guelleFiLv,"showValueWithLiters",nil,nil,tonumber(distAfterTitleFactor*linePadding),0,0)
										rowcounter = rowcounter - 1;
									else
										drawInfo(language.animals.mist,mistFiLv,"showValueWithLiters",nil,nil,tonumber(distAfterTitleFactor*linePadding),0,0)
										drawInfo(language.animals.guelle,guelleFiLv,"showValueWithLiters",nil,nil,tonumber(linePadding),0,0)
									end

									drawInfo(language.animals.produktivitaet,productionPercent,nil,nil,nil,tonumber(linePadding),0,0)
								end

								drawInfo(language.animals.sauberkeit,cleanlinessPercent,cleanlinessText,nil,nil,tonumber(distAfterTitleFactor*linePadding),0,0)

								drawInfo(language.fruits.wasser,waterFiLv,waterFiLvPct,math.floor(waterCpty),math.floor(waterCpty-waterFiLv),tonumber(linePadding),0,0)
								drawInfo(language.fruits.stroh, strawFiLv,strawFiLvPct,math.floor(strawCpty),math.floor(strawCpty-strawFiLv),tonumber(linePadding),0,0)

								-- wenn MoreBunkerSilo NICHT aktiv
								if MoreBunkerSiloIsActive == false then
									-- VERMUTETER BUG in LS19 oder Seasons - hier hart korrigiert
									-- drawInfo("<  " .. language.fruits.mais,maizeFiLv,maizeFiLvPct,math.floor(maizeCpty),math.floor(maizeCpty-maizeFiLv),tonumber(linePadding),0,0)
									drawInfo("<  " .. language.fruits.mais,maizeFiLv,maizeFiLvPct/2,math.floor(maizeCpty*2),math.floor((maizeCpty*2)-maizeFiLv),tonumber(linePadding),1,0)
								else
									-- Implementierung MOREBUNKERSILO (die beiden neuen Fruechte CCM und Grassilage)
									fruitsFiLv = maizeFiLv + ccmFiLv
									fruitsFiLvPct = maizeFiLvPct + ccmFiLvPct
									fruitsCpty = maizeCpty + ccmCpty
									if combiFiLvActive == false then
										-- VERMUTETER BUG in LS19 oder Seasons - hier hart korrigiert
										-- drawInfo(">  " .. language.fruits.mais,maizeFiLv,fruitsFiLvPct,math.floor(maizeCpty),math.floor(maizeCpty-fruitsFiLv),tonumber(linePadding),0,0)
										-- drawInfo(">  " .. language.fruits.ccm,ccmFiLv,fruitsFiLvPct,math.floor(ccmCpty),math.floor(ccmCpty-fruitsFiLv),tonumber(linePadding),0,0)
										drawInfo(">  " .. language.fruits.mais,maizeFiLv,fruitsFiLvPct/2,math.floor(maizeCpty*2),math.floor((maizeCpty*2)-fruitsFiLv),tonumber(linePadding),1,0)
										drawInfo(">  " .. language.fruits.ccm,ccmFiLv,fruitsFiLvPct/2,math.floor(ccmCpty*2),math.floor((ccmCpty*2)-fruitsFiLv),tonumber(linePadding),1,0)

										rowcounter = rowcounter + 1;
									else
										-- VERMUTETER BUG in LS19 oder Seasons - hier hart korrigiert
										-- drawInfo(language.fruits.mais .. " / " .. language.fruits.ccm,fruitsFiLv,fruitsFiLvPct,math.floor(fruitsCpty/2),math.floor((fruitsCpty/2)-fruitsFiLv),tonumber(linePadding),0,0)
										drawInfo(language.fruits.mais .. " / " .. language.fruits.ccm,fruitsFiLv,fruitsFiLvPct/2,math.floor((fruitsCpty/2)*2),math.floor(((fruitsCpty/2)*2)-fruitsFiLv),tonumber(linePadding),1,0)
										-- HALBIERUNGSPROBLEM (Mais + CCM nur 250 statt 500 ?) - Kapaazitaet nach der Summe NICHT halbiert
										-- drawInfo(language.fruits.mais .. " / " .. language.fruits.ccm,fruitsFiLv,fruitsFiLvPct,math.floor(fruitsCpty),math.floor(fruitsCpty-fruitsFiLv),tonumber(linePadding),0,0)
									end 
								end
					  
								if combiFiLvActive == false then
									fruitsFiLv = weizenFiLv + gersteFiLv
									fruitsFiLvPct = weizenFiLvPct + gersteFiLvPct
									-- fruitsCpty
									drawInfo("<  " .. language.fruits.weizen,weizenFiLv,fruitsFiLvPct,math.floor(weizenCpty),math.floor(weizenCpty-fruitsFiLv),tonumber(linePadding),0,0)
									drawInfo("<  " .. language.fruits.gerste,gersteFiLv,fruitsFiLvPct,math.floor(gersteCpty),math.floor(gersteCpty-fruitsFiLv),tonumber(linePadding),0,0)

									fruitsFiLv = sojaFiLv + rapsFiLv + sonnenblumenFiLv
									fruitsFiLvPct = sojaFiLvPct + rapsFiLvPct + sonnenblumenFiLvPct
									-- fruitsCpty
									drawInfo(">  " .. language.fruits.sojabohnen,sojaFiLv,fruitsFiLvPct,math.floor(sojaCpty),math.floor(sojaCpty-fruitsFiLv),tonumber(linePadding),0,0)
									drawInfo(">  " .. language.fruits.raps,rapsFiLv,fruitsFiLvPct,math.floor(rapsCpty),math.floor(rapsCpty-fruitsFiLv),tonumber(linePadding),0,0)
									drawInfo(">  " .. language.fruits.sonnenblumen,sonnenblumenFiLv,fruitsFiLvPct,math.floor(sonnenblumenCpty),math.floor(sonnenblumenCpty-fruitsFiLv),tonumber(linePadding),0,0)

									-- wenn Seasons NICHT aktiv
									if SeasonsIsActive == false then
										fruitsFiLv = kartoFiLv + ruebenFiLv
										fruitsFiLvPct = kartoFiLvPct + ruebenFiLvPct
										-- fruitsCpty
										drawInfo("<  " .. language.fruits.kartoffeln,kartoFiLv,fruitsFiLvPct,math.floor(kartoCpty),math.floor(kartoCpty-fruitsFiLv),tonumber(linePadding),0,0)
										drawInfo("<  " .. language.fruits.zuckerrueben,ruebenFiLv,fruitsFiLvPct,math.floor(ruebenCpty),math.floor(ruebenCpty-fruitsFiLv),tonumber(linePadding),0,0)
										rowcounter = rowcounter + 2;
									end

									rowcounter = rowcounter + 13;
								else	
									fruitsFiLv = weizenFiLv + gersteFiLv
									fruitsFiLvPct = weizenFiLvPct + gersteFiLvPct
									fruitsCpty = weizenCpty + gersteCpty
									drawInfo(language.fruits.weizen .. " / " .. language.fruits.gerste,fruitsFiLv,fruitsFiLvPct,math.floor(fruitsCpty/2),math.floor((fruitsCpty/2)-fruitsFiLv),tonumber(linePadding),0,0)

									fruitsFiLv = sojaFiLv + rapsFiLv + sonnenblumenFiLv
									fruitsFiLvPct = sojaFiLvPct + rapsFiLvPct + sonnenblumenFiLvPct
									fruitsCpty = sojaCpty + rapsCpty + sonnenblumenCpty
									-- German optimization (hardcoded)
									drawInfo("Soja" .. " / " .. language.fruits.raps .. " / " .. "Sonnenbl.",fruitsFiLv,fruitsFiLvPct,math.floor(fruitsCpty/3),math.floor((fruitsCpty/3)-fruitsFiLv),tonumber(linePadding),0,0)
									-- full text international
									-- drawInfo(language.fruits.sojabohnen .. " / " .. language.fruits.raps .. " / " .. language.fruits.sonnenblumen,fruitsFiLv,fruitsFiLvPct,math.floor(fruitsCpty/3),math.floor((fruitsCpty/3)-fruitsFiLv),tonumber(linePadding),0,0)

									-- wenn Seasons NICHT aktiv
									if SeasonsIsActive == false then
										fruitsFiLv = kartoFiLv + ruebenFiLv
										fruitsFiLvPct = kartoFiLvPct + ruebenFiLvPct
										fruitsCpty = kartoCpty + ruebenCpty
										drawInfo(language.fruits.kartoffeln .. " / " .. language.fruits.zuckerrueben,fruitsFiLv,fruitsFiLvPct,math.floor(fruitsCpty/2),math.floor((fruitsCpty/2)-fruitsFiLv),tonumber(linePadding),0,0)
										rowcounter = rowcounter + 1;
									end

									rowcounter = rowcounter + 10;
								end 
							else 
								-- neuer/leerer Stall
								if minimizeHudActive == true then
									drawInfo(language.animals.schweinebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,0) 
								else
									drawInfo(language.animals.schweinebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,0) 
								end
								drawPlayerOnHud(playerName);

								rowcounter = rowcounter + 1;

								-- AUTOMATISCHE Neuberechnung - Aufruf der ID-Messfunktion, notwendig bei Stallkauf SCHWEINE
								if IDfoundFlagCCM == 0 and MoreBunkerSiloIsActive == true then
									-- WICHTIG: BEIDE Werte sicherheitshalber neu messen (wie Erstberechnung)
									searchFlagDynID = 1
									IDfoundFlagGRSIL = 0

									getMBSdynamicIDs()
									searchFlagDynID = 2
								end
							end
							createOverlayForAnimalsHUD("pigs",rowcounter,3,numberOfAnimals)
						end
					end
				end
			end
		end

		-- HORSES
		if animalsHorseHudActive == true then
			local stallnummer = 0;
			local stallzaehler = 0;
			for _,husbandry in pairs(g_currentMission.husbandries) do
				local rowcounter = 0;

				if checkisOwnerOfFarm(husbandry) == true then 
					stallnummer = stallnummer + 1;

					if husbandry.modulesByName.animals.animalType == "HORSE" then
						stallzaehler = stallzaehler + 1;
						local numberOfAnimals = countAnimals(husbandry);
						local playerName = drawPlayerNameWithLocationOfCurrentBuildingID(husbandry);

						local tieretier = " ".. g_i18n:getText("word_animals")
						if numberOfAnimals == 1 then
							tieretier = " ".. g_i18n:getText("word_animal")
						end;

						local dynpadding = 1.72;
						if stallzaehler == 1 then
							dynpadding = 2.15;
						end;

						-- Anzeige nur, wenn Spieler nher als radiusBarns entfernt
						-- locationNearBuildingIDTable[BuildingTableIndex]
						if showNearBarnsOnly == true and not tabContVal(locationNearBuildingIDTable, husbandry.id) then
							-- no horse barn nearer than radiusBarns
							if minimizeHudActive == true then
								-- drawInfo(language.animals.pferdebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_distance") .. " > " .. radiusBarns .. "m","","","",tonumber(dynpadding*linePadding),0,1)
								drawInfo(language.animals.pferdebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,1) 
							else
								-- drawInfo(language.animals.pferdebestand,"","","",g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_distance") .. " > " .. radiusBarns .. "m",tonumber(dynpadding*linePadding),0,1)
								drawInfo(language.animals.pferdebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,1) 
							end
							drawPlayerOnHud(playerName);

							rowcounter = rowcounter + 1;
							createOverlayForAnimalsHUD("horse",rowcounter,4,-1)
						else
							if numberOfAnimals > 0 then
								local waterFiLv,waterFiLvPct,waterCpty  = getFiLvWaterFromId(varID_water,husbandry)
								local strawFiLv,strawFiLvPct,strawCpty  = getFiLvStrawFromId(varID_straw,husbandry)
								 
								local haferFiLv,haferFiLvPct,haferCpty  = getFiLvFoodFromId(varID_oat,husbandry)
								local heuFiLv,heuFiLvPct,heuCpty        = getFiLvFoodFromId(varID_drygrass,husbandry)
								
								if minimizeHudActive == true then
									drawInfo(language.animals.pferdebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,0) 
								else
									drawInfo(language.animals.pferdebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,0) 
								end
								drawPlayerOnHud(playerName);

								drawInfo(language.fruits.wasser,waterFiLv,waterFiLvPct,math.floor(waterCpty),math.floor(waterCpty-waterFiLv),tonumber(distAfterTitleFactor*linePadding),0,0)
								drawInfo(language.fruits.stroh,strawFiLv,strawFiLvPct,math.floor(strawCpty),math.floor(strawCpty-strawFiLv),tonumber(linePadding),0,0)
								drawInfo(language.fruits.hafer,haferFiLv,haferFiLvPct,math.floor(haferCpty),math.floor(haferCpty-haferFiLv),tonumber(linePadding),0,0)
								drawInfo(language.fruits.heu,heuFiLv,heuFiLvPct,math.floor(heuCpty),math.floor(heuCpty-heuFiLv),tonumber(linePadding),0,0)
								rowcounter = rowcounter + 5;
							else
								-- neuer/leerer Stall
								if minimizeHudActive == true then
									drawInfo(language.animals.pferdebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,0) 
								else
									drawInfo(language.animals.pferdebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,0) 
								end
								drawPlayerOnHud(playerName);

								rowcounter = rowcounter + 1;
							end
							createOverlayForAnimalsHUD("horse",rowcounter,4,numberOfAnimals)
						end
					end
				end
			end
		end

		-- SHEEPS
		if animalsSheepHudActive == true then
			local stallnummer = 0;
			local stallzaehler = 0;
			for _,husbandry in pairs(g_currentMission.husbandries) do
				local rowcounter = 0;

				if checkisOwnerOfFarm(husbandry) == true then 
					stallnummer = stallnummer + 1;

					if husbandry.modulesByName.animals.animalType == "SHEEP" then
						stallzaehler = stallzaehler + 1;
						local numberOfAnimals = countAnimals(husbandry);
						local playerName = drawPlayerNameWithLocationOfCurrentBuildingID(husbandry);

						local tieretier = " ".. g_i18n:getText("word_animals")
						if numberOfAnimals == 1 then
							tieretier = " ".. g_i18n:getText("word_animal")
						end;

						local dynpadding = 1.72;
						if stallzaehler == 1 then
							dynpadding = 2.15;
						end;

						-- Anzeige nur, wenn Spieler nher als radiusBarns entfernt
						-- locationNearBuildingIDTable[BuildingTableIndex]
						if showNearBarnsOnly == true and not tabContVal(locationNearBuildingIDTable, husbandry.id) then
							-- no sheep barn nearer than radiusBarns
							if minimizeHudActive == true then
								-- drawInfo(language.animals.schafebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_distance") .. " > " .. radiusBarns .. "m","","","",tonumber(dynpadding*linePadding),0,1)
								drawInfo(language.animals.schafebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,1) 
							else
								-- drawInfo(language.animals.schafebestand,"","","",g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_distance") .. " > " .. radiusBarns .. "m",tonumber(dynpadding*linePadding),0,1)
								drawInfo(language.animals.schafebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,1) 
							end
							drawPlayerOnHud(playerName);

							rowcounter = rowcounter + 1;
							createOverlayForAnimalsHUD("sheep",rowcounter,5,-1)
						else
							if numberOfAnimals > 0 then
								local cleanliness = getCleanlinessFactorInPercent(husbandry);
								local cleanlinessPercent,cleanlinessText  = setCleanLinessColorIndicatorForMaxAndMinPercentValues(cleanliness)

								local production = getProductionFactorInPercent(husbandry);
								local productionPercent  = setProductionColorIndicatorForMaxAndMinPercentValues(production)
					   
								local waterFiLv,waterFiLvPct,waterCpty                 = getFiLvWaterFromId(varID_water,husbandry)
								local grasFiLv,grasFiLvPct,grasCpty                    = getFiLvFoodFromId(varID_grass,husbandry)
								local heuFiLv,heuFiLvPct,heuCpty                       = getFiLvFoodFromId(varID_drygrass,husbandry)

								-- Implementierung BUNKERSILO (die beiden neuen Fruechte CCM und Grassilage)
								local grassilageFiLv = 0
								local grassilageFiLvPct = 0
								local grassilageCpty = 0
								-- kein Aufruf, wenn ID unbekannt
								if IDfoundFlagGRSIL == 1 then
									grassilageFiLv,grassilageFiLvPct,grassilageCpty    = getFiLvFoodFromId(varID_grassilage,husbandry)
								end

								local woolFiLv  = getFiLvPallets(husbandry) -- no 2nd parameter!!
								
								-- TEST - Anzeige der Stall-Gesamtkapazitt ... nur in diesem folgenden Fall NICHT anzeigen (Platzproblem)
								-- if combiFiLvActive == false and minimizeHudActive == true then

								if minimizeHudActive == true then
									drawInfo(language.animals.schafebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,0) 
								else
									drawInfo(language.animals.schafebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,0) 
								end
								drawPlayerOnHud(playerName);

								if shortHudActive == true then
									-- nicht anzeigen
									rowcounter = rowcounter - 2;
								else
									drawInfo(language.animals.wolle, woolFiLv,"showValueWithNothing",nil,nil,tonumber(distAfterTitleFactor*linePadding),0,0)
									drawInfo(language.animals.produktivitaet,productionPercent,nil,nil,nil,tonumber(linePadding),0,0)
								end

								drawInfo(language.animals.sauberkeit,cleanlinessPercent,cleanlinessText,nil,nil,tonumber(distAfterTitleFactor*linePadding),0,0) 

								drawInfo(language.fruits.wasser,waterFiLv,waterFiLvPct,math.floor(waterCpty),math.floor(waterCpty-waterFiLv),tonumber(linePadding),0,0)
					   
								fruitsFiLv = grasFiLv + heuFiLv + grassilageFiLv
								fruitsFiLvPct = grasFiLvPct + heuFiLvPct + grassilageFiLvPct
								fruitsCpty = grasCpty + heuCpty + grassilageCpty
								if combiFiLvActive == false then
									drawInfo(">  " .. language.fruits.gras,grasFiLv,fruitsFiLvPct,math.floor(grasCpty),math.floor(grasCpty-fruitsFiLv),tonumber(linePadding),0,0)
									drawInfo(">  " .. language.fruits.heu,heuFiLv,fruitsFiLvPct,math.floor(heuCpty),math.floor(heuCpty-fruitsFiLv),tonumber(linePadding),0,0)
									drawInfo(">  " .. language.fruits.grassilage,grassilageFiLv,fruitsFiLvPct,math.floor(grassilageCpty),math.floor(grassilageCpty-fruitsFiLv),tonumber(linePadding),0,0)
									rowcounter = rowcounter + 8;
								else
									drawInfo(language.fruits.gras .. " / " .. language.fruits.heu .. " / " .. language.fruits.grassilage, fruitsFiLv,fruitsFiLvPct,math.floor(fruitsCpty/3),math.floor((fruitsCpty/3)-fruitsFiLv),tonumber(linePadding),0,0)
									rowcounter = rowcounter + 6;
								end
							else
								-- neuer/leerer Stall
								if minimizeHudActive == true then
									drawInfo(language.animals.schafebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer .. " | " .. numberOfAnimals .. tieretier,"","","",tonumber(dynpadding*linePadding),0,0) 
								else
									drawInfo(language.animals.schafebestand,g_i18n:getText("word_barn") .. " " .. stallzaehler .. " | " .. g_i18n:getText("word_numbr") .. " " .. stallnummer,"","",numberOfAnimals .. tieretier,tonumber(dynpadding*linePadding),0,0) 
								end
								drawPlayerOnHud(playerName);

								rowcounter = rowcounter + 1;

								-- AUTOMATISCHE Neuberechnung - Aufruf der ID-Messfunktion, notwendig bei Stallkauf SCHAFE (oder Kuehe)
								if IDfoundFlagGRSIL == 0 and MoreBunkerSiloIsActive == true then
									-- WICHTIG: BEIDE Werte sicherheitshalber neu messen (wie Erstberechnung)
									searchFlagDynID = 1
									IDfoundFlagCCM = 0

									getMBSdynamicIDs()
									searchFlagDynID = 2
								end
							end
							createOverlayForAnimalsHUD("sheep",rowcounter,5,numberOfAnimals)
						end
					end
				end
			end
		end    -- end animals sheep here
	end        -- show/hide all on hud
end            -- draw function ends here

